
_Separate_hexP10:

;rc522.c,133 :: 		unsigned char Separate_hexP10(unsigned char val){
;rc522.c,134 :: 		val = val & 0xF0;
	MOVLW       240
	ANDWF       FARG_Separate_hexP10_val+0, 0 
	MOVWF       R2 
	MOVF        R2, 0 
	MOVWF       FARG_Separate_hexP10_val+0 
;rc522.c,135 :: 		val = val >> 4;
	MOVF        R2, 0 
	MOVWF       R1 
	RRCF        R1, 1 
	BCF         R1, 7 
	RRCF        R1, 1 
	BCF         R1, 7 
	RRCF        R1, 1 
	BCF         R1, 7 
	RRCF        R1, 1 
	BCF         R1, 7 
	MOVF        R1, 0 
	MOVWF       FARG_Separate_hexP10_val+0 
;rc522.c,137 :: 		if (val < 10)
	MOVLW       10
	SUBWF       R1, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_Separate_hexP100
;rc522.c,138 :: 		return val + 48;
	MOVLW       48
	ADDWF       FARG_Separate_hexP10_val+0, 0 
	MOVWF       R0 
	GOTO        L_end_Separate_hexP10
L_Separate_hexP100:
;rc522.c,140 :: 		return val + 55;
	MOVLW       55
	ADDWF       FARG_Separate_hexP10_val+0, 0 
	MOVWF       R0 
;rc522.c,141 :: 		}
L_end_Separate_hexP10:
	RETURN      0
; end of _Separate_hexP10

_Separate_hexP1:

;rc522.c,149 :: 		unsigned char Separate_hexP1(unsigned char val){
;rc522.c,150 :: 		val = val & 0x0F;
	MOVLW       15
	ANDWF       FARG_Separate_hexP1_val+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       FARG_Separate_hexP1_val+0 
;rc522.c,151 :: 		if (val < 10)
	MOVLW       10
	SUBWF       R1, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_Separate_hexP12
;rc522.c,152 :: 		return val + 48;
	MOVLW       48
	ADDWF       FARG_Separate_hexP1_val+0, 0 
	MOVWF       R0 
	GOTO        L_end_Separate_hexP1
L_Separate_hexP12:
;rc522.c,154 :: 		return val + 55;
	MOVLW       55
	ADDWF       FARG_Separate_hexP1_val+0, 0 
	MOVWF       R0 
;rc522.c,155 :: 		}
L_end_Separate_hexP1:
	RETURN      0
; end of _Separate_hexP1

_Write_MFRC522:

;rc522.c,163 :: 		void Write_MFRC522(unsigned char addr, unsigned char val){
;rc522.c,164 :: 		MFRC522_CS = 0;
	BCF         RA0_bit+0, BitPos(RA0_bit+0) 
;rc522.c,167 :: 		Soft_SPI_Write((addr<<1)&0x7E);
	MOVF        FARG_Write_MFRC522_addr+0, 0 
	MOVWF       FARG_Soft_SPI_Write_sdata+0 
	RLCF        FARG_Soft_SPI_Write_sdata+0, 1 
	BCF         FARG_Soft_SPI_Write_sdata+0, 0 
	MOVLW       126
	ANDWF       FARG_Soft_SPI_Write_sdata+0, 1 
	CALL        _Soft_SPI_Write+0, 0
;rc522.c,168 :: 		Soft_SPI_Write(val);
	MOVF        FARG_Write_MFRC522_val+0, 0 
	MOVWF       FARG_Soft_SPI_Write_sdata+0 
	CALL        _Soft_SPI_Write+0, 0
;rc522.c,170 :: 		MFRC522_CS = 1;
	BSF         RA0_bit+0, BitPos(RA0_bit+0) 
;rc522.c,171 :: 		}
L_end_Write_MFRC522:
	RETURN      0
; end of _Write_MFRC522

_Read_MFRC522:

;rc522.c,180 :: 		unsigned char Read_MFRC522(unsigned char addr){
;rc522.c,183 :: 		MFRC522_CS = 0;
	BCF         RA0_bit+0, BitPos(RA0_bit+0) 
;rc522.c,186 :: 		Soft_SPI_Write(((addr<<1)&0x7E) | 0x80);
	MOVF        FARG_Read_MFRC522_addr+0, 0 
	MOVWF       FARG_Soft_SPI_Write_sdata+0 
	RLCF        FARG_Soft_SPI_Write_sdata+0, 1 
	BCF         FARG_Soft_SPI_Write_sdata+0, 0 
	MOVLW       126
	ANDWF       FARG_Soft_SPI_Write_sdata+0, 1 
	BSF         FARG_Soft_SPI_Write_sdata+0, 7 
	CALL        _Soft_SPI_Write+0, 0
;rc522.c,187 :: 		val = Soft_SPI_Read(0x00);
	CLRF        FARG_Soft_SPI_Read_sdata+0 
	CALL        _Soft_SPI_Read+0, 0
;rc522.c,189 :: 		MFRC522_CS = 1;
	BSF         RA0_bit+0, BitPos(RA0_bit+0) 
;rc522.c,191 :: 		return val;
;rc522.c,192 :: 		}
L_end_Read_MFRC522:
	RETURN      0
; end of _Read_MFRC522

_SetBitMask:

;rc522.c,200 :: 		void SetBitMask(unsigned char reg, unsigned char mask){
;rc522.c,203 :: 		tmp = Read_MFRC522(reg);
	MOVF        FARG_SetBitMask_reg+0, 0 
	MOVWF       FARG_Read_MFRC522_addr+0 
	CALL        _Read_MFRC522+0, 0
;rc522.c,204 :: 		Write_MFRC522(reg, tmp | mask);  // set bit mask
	MOVF        FARG_SetBitMask_reg+0, 0 
	MOVWF       FARG_Write_MFRC522_addr+0 
	MOVF        FARG_SetBitMask_mask+0, 0 
	IORWF       R0, 0 
	MOVWF       FARG_Write_MFRC522_val+0 
	CALL        _Write_MFRC522+0, 0
;rc522.c,205 :: 		}
L_end_SetBitMask:
	RETURN      0
; end of _SetBitMask

_ClearBitMask:

;rc522.c,214 :: 		void ClearBitMask(unsigned char reg, unsigned char mask){
;rc522.c,216 :: 		tmp = Read_MFRC522(reg);
	MOVF        FARG_ClearBitMask_reg+0, 0 
	MOVWF       FARG_Read_MFRC522_addr+0 
	CALL        _Read_MFRC522+0, 0
;rc522.c,217 :: 		Write_MFRC522(reg, tmp & (~mask));  // clear bit mask
	MOVF        FARG_ClearBitMask_reg+0, 0 
	MOVWF       FARG_Write_MFRC522_addr+0 
	COMF        FARG_ClearBitMask_mask+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	ANDWF       R0, 0 
	MOVWF       FARG_Write_MFRC522_val+0 
	CALL        _Write_MFRC522+0, 0
;rc522.c,218 :: 		}
L_end_ClearBitMask:
	RETURN      0
; end of _ClearBitMask

_AntennaOn:

;rc522.c,227 :: 		void AntennaOn(void){
;rc522.c,230 :: 		temp = Read_MFRC522(TxControlReg);
	MOVLW       20
	MOVWF       FARG_Read_MFRC522_addr+0 
	CALL        _Read_MFRC522+0, 0
;rc522.c,231 :: 		if (!(temp & 0x03))
	MOVLW       3
	ANDWF       R0, 1 
	MOVF        R0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_AntennaOn4
;rc522.c,232 :: 		SetBitMask(TxControlReg, 0x03);
	MOVLW       20
	MOVWF       FARG_SetBitMask_reg+0 
	MOVLW       3
	MOVWF       FARG_SetBitMask_mask+0 
	CALL        _SetBitMask+0, 0
L_AntennaOn4:
;rc522.c,233 :: 		}
L_end_AntennaOn:
	RETURN      0
; end of _AntennaOn

_AntennaOff:

;rc522.c,242 :: 		void AntennaOff(void){
;rc522.c,243 :: 		ClearBitMask(TxControlReg, 0x03);
	MOVLW       20
	MOVWF       FARG_ClearBitMask_reg+0 
	MOVLW       3
	MOVWF       FARG_ClearBitMask_mask+0 
	CALL        _ClearBitMask+0, 0
;rc522.c,244 :: 		}
L_end_AntennaOff:
	RETURN      0
; end of _AntennaOff

_MFRC522_Reset:

;rc522.c,253 :: 		void MFRC522_Reset(void){
;rc522.c,254 :: 		Write_MFRC522(CommandReg, PCD_RESETPHASE);
	MOVLW       1
	MOVWF       FARG_Write_MFRC522_addr+0 
	MOVLW       15
	MOVWF       FARG_Write_MFRC522_val+0 
	CALL        _Write_MFRC522+0, 0
;rc522.c,255 :: 		}
L_end_MFRC522_Reset:
	RETURN      0
; end of _MFRC522_Reset

_MFRC522_Init:

;rc522.c,264 :: 		void MFRC522_Init(void){
;rc522.c,265 :: 		MFRC522_RST = 1;
	BSF         RA5_bit+0, BitPos(RA5_bit+0) 
;rc522.c,267 :: 		MFRC522_Reset();
	CALL        _MFRC522_Reset+0, 0
;rc522.c,270 :: 		Write_MFRC522(TModeReg, 0x8D);                //Tauto=1; f(Timer) = 6.78MHz/TPreScaler
	MOVLW       42
	MOVWF       FARG_Write_MFRC522_addr+0 
	MOVLW       141
	MOVWF       FARG_Write_MFRC522_val+0 
	CALL        _Write_MFRC522+0, 0
;rc522.c,271 :: 		Write_MFRC522(TPrescalerReg, 0x3E);        //TModeReg[3..0] + TPrescalerReg
	MOVLW       43
	MOVWF       FARG_Write_MFRC522_addr+0 
	MOVLW       62
	MOVWF       FARG_Write_MFRC522_val+0 
	CALL        _Write_MFRC522+0, 0
;rc522.c,272 :: 		Write_MFRC522(TReloadRegL, 30);
	MOVLW       45
	MOVWF       FARG_Write_MFRC522_addr+0 
	MOVLW       30
	MOVWF       FARG_Write_MFRC522_val+0 
	CALL        _Write_MFRC522+0, 0
;rc522.c,273 :: 		Write_MFRC522(TReloadRegH, 0);
	MOVLW       44
	MOVWF       FARG_Write_MFRC522_addr+0 
	CLRF        FARG_Write_MFRC522_val+0 
	CALL        _Write_MFRC522+0, 0
;rc522.c,275 :: 		Write_MFRC522(TxAutoReg, 0x40);                //100%ASK
	MOVLW       21
	MOVWF       FARG_Write_MFRC522_addr+0 
	MOVLW       64
	MOVWF       FARG_Write_MFRC522_val+0 
	CALL        _Write_MFRC522+0, 0
;rc522.c,276 :: 		Write_MFRC522(ModeReg, 0x3D);                //CRC Initial value 0x6363
	MOVLW       17
	MOVWF       FARG_Write_MFRC522_addr+0 
	MOVLW       61
	MOVWF       FARG_Write_MFRC522_val+0 
	CALL        _Write_MFRC522+0, 0
;rc522.c,278 :: 		AntennaOn();                //Open the antenna
	CALL        _AntennaOn+0, 0
;rc522.c,279 :: 		}
L_end_MFRC522_Init:
	RETURN      0
; end of _MFRC522_Init

_MFRC522_Request:

;rc522.c,293 :: 		unsigned char MFRC522_Request(unsigned char reqMode, unsigned char *TagType){
;rc522.c,297 :: 		Write_MFRC522(BitFramingReg, 0x07);                //TxLastBists = BitFramingReg[2..0]        ???
	MOVLW       13
	MOVWF       FARG_Write_MFRC522_addr+0 
	MOVLW       7
	MOVWF       FARG_Write_MFRC522_val+0 
	CALL        _Write_MFRC522+0, 0
;rc522.c,299 :: 		TagType[0] = reqMode;
	MOVFF       FARG_MFRC522_Request_TagType+0, FSR1L+0
	MOVFF       FARG_MFRC522_Request_TagType+1, FSR1H+0
	MOVF        FARG_MFRC522_Request_reqMode+0, 0 
	MOVWF       POSTINC1+0 
;rc522.c,300 :: 		status = MFRC522_ToCard(PCD_TRANSCEIVE, TagType, 1, TagType, &backBits);
	MOVLW       12
	MOVWF       FARG_MFRC522_ToCard_command+0 
	MOVF        FARG_MFRC522_Request_TagType+0, 0 
	MOVWF       FARG_MFRC522_ToCard_sendData+0 
	MOVF        FARG_MFRC522_Request_TagType+1, 0 
	MOVWF       FARG_MFRC522_ToCard_sendData+1 
	MOVLW       1
	MOVWF       FARG_MFRC522_ToCard_sendLen+0 
	MOVF        FARG_MFRC522_Request_TagType+0, 0 
	MOVWF       FARG_MFRC522_ToCard_backData+0 
	MOVF        FARG_MFRC522_Request_TagType+1, 0 
	MOVWF       FARG_MFRC522_ToCard_backData+1 
	MOVLW       MFRC522_Request_backBits_L0+0
	MOVWF       FARG_MFRC522_ToCard_backLen+0 
	MOVLW       hi_addr(MFRC522_Request_backBits_L0+0)
	MOVWF       FARG_MFRC522_ToCard_backLen+1 
	CALL        _MFRC522_ToCard+0, 0
	MOVF        R0, 0 
	MOVWF       MFRC522_Request_status_L0+0 
;rc522.c,302 :: 		if ((status != MI_OK) || (backBits != 0x10))
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__MFRC522_Request97
	MOVF        MFRC522_Request_backBits_L0+0, 0 
	XORLW       16
	BTFSS       STATUS+0, 2 
	GOTO        L__MFRC522_Request97
	GOTO        L_MFRC522_Request7
L__MFRC522_Request97:
;rc522.c,303 :: 		status = MI_ERR;
	MOVLW       2
	MOVWF       MFRC522_Request_status_L0+0 
L_MFRC522_Request7:
;rc522.c,305 :: 		return status;
	MOVF        MFRC522_Request_status_L0+0, 0 
	MOVWF       R0 
;rc522.c,306 :: 		}
L_end_MFRC522_Request:
	RETURN      0
; end of _MFRC522_Request

_MFRC522_ToCard:

;rc522.c,319 :: 		unsigned char MFRC522_ToCard(unsigned char command, unsigned char *sendData, unsigned char sendLen, unsigned char *backData, unsigned int *backLen){
;rc522.c,320 :: 		unsigned char status = MI_ERR;
	MOVLW       2
	MOVWF       MFRC522_ToCard_status_L0+0 
	CLRF        MFRC522_ToCard_irqEn_L0+0 
	CLRF        MFRC522_ToCard_waitIRq_L0+0 
;rc522.c,327 :: 		switch (command){
	GOTO        L_MFRC522_ToCard8
;rc522.c,328 :: 		case PCD_AUTHENT:     // Certification cards close
L_MFRC522_ToCard10:
;rc522.c,329 :: 		irqEn   = 0x12;
	MOVLW       18
	MOVWF       MFRC522_ToCard_irqEn_L0+0 
;rc522.c,330 :: 		waitIRq = 0x10;
	MOVLW       16
	MOVWF       MFRC522_ToCard_waitIRq_L0+0 
;rc522.c,331 :: 		break;
	GOTO        L_MFRC522_ToCard9
;rc522.c,332 :: 		case PCD_TRANSCEIVE:  // Transmit FIFO data
L_MFRC522_ToCard11:
;rc522.c,333 :: 		irqEn   = 0x77;
	MOVLW       119
	MOVWF       MFRC522_ToCard_irqEn_L0+0 
;rc522.c,334 :: 		waitIRq = 0x30;
	MOVLW       48
	MOVWF       MFRC522_ToCard_waitIRq_L0+0 
;rc522.c,335 :: 		break;
	GOTO        L_MFRC522_ToCard9
;rc522.c,336 :: 		default:
L_MFRC522_ToCard12:
;rc522.c,337 :: 		break;
	GOTO        L_MFRC522_ToCard9
;rc522.c,338 :: 		}
L_MFRC522_ToCard8:
	MOVF        FARG_MFRC522_ToCard_command+0, 0 
	XORLW       14
	BTFSC       STATUS+0, 2 
	GOTO        L_MFRC522_ToCard10
	MOVF        FARG_MFRC522_ToCard_command+0, 0 
	XORLW       12
	BTFSC       STATUS+0, 2 
	GOTO        L_MFRC522_ToCard11
	GOTO        L_MFRC522_ToCard12
L_MFRC522_ToCard9:
;rc522.c,340 :: 		Write_MFRC522(CommIEnReg, irqEn|0x80); //Interrupt request
	MOVLW       2
	MOVWF       FARG_Write_MFRC522_addr+0 
	MOVLW       128
	IORWF       MFRC522_ToCard_irqEn_L0+0, 0 
	MOVWF       FARG_Write_MFRC522_val+0 
	CALL        _Write_MFRC522+0, 0
;rc522.c,341 :: 		ClearBitMask(CommIrqReg, 0x80);        //Clear all interrupt request bit
	MOVLW       4
	MOVWF       FARG_ClearBitMask_reg+0 
	MOVLW       128
	MOVWF       FARG_ClearBitMask_mask+0 
	CALL        _ClearBitMask+0, 0
;rc522.c,342 :: 		SetBitMask(FIFOLevelReg, 0x80);        //FlushBuffer=1, FIFO Initialization
	MOVLW       10
	MOVWF       FARG_SetBitMask_reg+0 
	MOVLW       128
	MOVWF       FARG_SetBitMask_mask+0 
	CALL        _SetBitMask+0, 0
;rc522.c,344 :: 		Write_MFRC522(CommandReg, PCD_IDLE);   //NO action; Cancel the current command???
	MOVLW       1
	MOVWF       FARG_Write_MFRC522_addr+0 
	CLRF        FARG_Write_MFRC522_val+0 
	CALL        _Write_MFRC522+0, 0
;rc522.c,347 :: 		for (i=0; i<sendLen; i++)
	CLRF        MFRC522_ToCard_i_L0+0 
L_MFRC522_ToCard13:
	MOVF        FARG_MFRC522_ToCard_sendLen+0, 0 
	SUBWF       MFRC522_ToCard_i_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_MFRC522_ToCard14
;rc522.c,348 :: 		Write_MFRC522(FIFODataReg, sendData[i]);
	MOVLW       9
	MOVWF       FARG_Write_MFRC522_addr+0 
	MOVF        MFRC522_ToCard_i_L0+0, 0 
	ADDWF       FARG_MFRC522_ToCard_sendData+0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      FARG_MFRC522_ToCard_sendData+1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Write_MFRC522_val+0 
	CALL        _Write_MFRC522+0, 0
;rc522.c,347 :: 		for (i=0; i<sendLen; i++)
	INCF        MFRC522_ToCard_i_L0+0, 1 
;rc522.c,348 :: 		Write_MFRC522(FIFODataReg, sendData[i]);
	GOTO        L_MFRC522_ToCard13
L_MFRC522_ToCard14:
;rc522.c,351 :: 		Write_MFRC522(CommandReg, command);
	MOVLW       1
	MOVWF       FARG_Write_MFRC522_addr+0 
	MOVF        FARG_MFRC522_ToCard_command+0, 0 
	MOVWF       FARG_Write_MFRC522_val+0 
	CALL        _Write_MFRC522+0, 0
;rc522.c,352 :: 		if (command == PCD_TRANSCEIVE)
	MOVF        FARG_MFRC522_ToCard_command+0, 0 
	XORLW       12
	BTFSS       STATUS+0, 2 
	GOTO        L_MFRC522_ToCard16
;rc522.c,353 :: 		SetBitMask(BitFramingReg, 0x80);                //StartSend=1,transmission of data starts
	MOVLW       13
	MOVWF       FARG_SetBitMask_reg+0 
	MOVLW       128
	MOVWF       FARG_SetBitMask_mask+0 
	CALL        _SetBitMask+0, 0
L_MFRC522_ToCard16:
;rc522.c,356 :: 		i = 2000;        //i according to the clock frequency adjustment, the operator M1 card maximum waiting time 25ms???
	MOVLW       208
	MOVWF       MFRC522_ToCard_i_L0+0 
;rc522.c,357 :: 		do{
L_MFRC522_ToCard17:
;rc522.c,360 :: 		n = Read_MFRC522(CommIrqReg);
	MOVLW       4
	MOVWF       FARG_Read_MFRC522_addr+0 
	CALL        _Read_MFRC522+0, 0
	MOVF        R0, 0 
	MOVWF       MFRC522_ToCard_n_L0+0 
;rc522.c,361 :: 		i--;
	DECF        MFRC522_ToCard_i_L0+0, 1 
;rc522.c,363 :: 		while ((i!=0) && !(n&0x01) && !(n&waitIRq));
	MOVF        MFRC522_ToCard_i_L0+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L__MFRC522_ToCard98
	BTFSC       MFRC522_ToCard_n_L0+0, 0 
	GOTO        L__MFRC522_ToCard98
	MOVF        MFRC522_ToCard_waitIRq_L0+0, 0 
	ANDWF       MFRC522_ToCard_n_L0+0, 0 
	MOVWF       R0 
	BTFSS       STATUS+0, 2 
	GOTO        L__MFRC522_ToCard98
	GOTO        L_MFRC522_ToCard17
L__MFRC522_ToCard98:
;rc522.c,365 :: 		ClearBitMask(BitFramingReg, 0x80);                        //StartSend=0
	MOVLW       13
	MOVWF       FARG_ClearBitMask_reg+0 
	MOVLW       128
	MOVWF       FARG_ClearBitMask_mask+0 
	CALL        _ClearBitMask+0, 0
;rc522.c,367 :: 		if (i != 0){
	MOVF        MFRC522_ToCard_i_L0+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_MFRC522_ToCard22
;rc522.c,368 :: 		if(!(Read_MFRC522(ErrorReg) & 0x1B)){        //BufferOvfl Collerr CRCErr ProtecolErr
	MOVLW       6
	MOVWF       FARG_Read_MFRC522_addr+0 
	CALL        _Read_MFRC522+0, 0
	MOVLW       27
	ANDWF       R0, 1 
	MOVF        R0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_MFRC522_ToCard23
;rc522.c,369 :: 		status = MI_OK;
	CLRF        MFRC522_ToCard_status_L0+0 
;rc522.c,370 :: 		if (n & irqEn & 0x01)
	MOVF        MFRC522_ToCard_irqEn_L0+0, 0 
	ANDWF       MFRC522_ToCard_n_L0+0, 0 
	MOVWF       R1 
	BTFSS       R1, 0 
	GOTO        L_MFRC522_ToCard24
;rc522.c,371 :: 		status = MI_NOTAGERR;
	MOVLW       1
	MOVWF       MFRC522_ToCard_status_L0+0 
L_MFRC522_ToCard24:
;rc522.c,373 :: 		if (command == PCD_TRANSCEIVE){
	MOVF        FARG_MFRC522_ToCard_command+0, 0 
	XORLW       12
	BTFSS       STATUS+0, 2 
	GOTO        L_MFRC522_ToCard25
;rc522.c,374 :: 		n = Read_MFRC522(FIFOLevelReg);
	MOVLW       10
	MOVWF       FARG_Read_MFRC522_addr+0 
	CALL        _Read_MFRC522+0, 0
	MOVF        R0, 0 
	MOVWF       MFRC522_ToCard_n_L0+0 
;rc522.c,375 :: 		lastBits = Read_MFRC522(ControlReg) & 0x07;
	MOVLW       12
	MOVWF       FARG_Read_MFRC522_addr+0 
	CALL        _Read_MFRC522+0, 0
	MOVLW       7
	ANDWF       R0, 1 
	MOVF        R0, 0 
	MOVWF       MFRC522_ToCard_lastBits_L0+0 
;rc522.c,376 :: 		if (lastBits)
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_MFRC522_ToCard26
;rc522.c,377 :: 		*backLen = (n-1)*8 + lastBits;
	DECF        MFRC522_ToCard_n_L0+0, 0 
	MOVWF       R3 
	CLRF        R4 
	MOVLW       0
	SUBWFB      R4, 1 
	MOVLW       3
	MOVWF       R2 
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	MOVF        R2, 0 
L__MFRC522_ToCard117:
	BZ          L__MFRC522_ToCard118
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	ADDLW       255
	GOTO        L__MFRC522_ToCard117
L__MFRC522_ToCard118:
	MOVF        MFRC522_ToCard_lastBits_L0+0, 0 
	ADDWF       R0, 1 
	MOVLW       0
	ADDWFC      R1, 1 
	MOVFF       FARG_MFRC522_ToCard_backLen+0, FSR1L+0
	MOVFF       FARG_MFRC522_ToCard_backLen+1, FSR1H+0
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
	GOTO        L_MFRC522_ToCard27
L_MFRC522_ToCard26:
;rc522.c,379 :: 		*backLen = n*8;
	MOVLW       3
	MOVWF       R2 
	MOVF        MFRC522_ToCard_n_L0+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        R2, 0 
L__MFRC522_ToCard119:
	BZ          L__MFRC522_ToCard120
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	ADDLW       255
	GOTO        L__MFRC522_ToCard119
L__MFRC522_ToCard120:
	MOVFF       FARG_MFRC522_ToCard_backLen+0, FSR1L+0
	MOVFF       FARG_MFRC522_ToCard_backLen+1, FSR1H+0
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
L_MFRC522_ToCard27:
;rc522.c,381 :: 		if (n == 0)
	MOVF        MFRC522_ToCard_n_L0+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_MFRC522_ToCard28
;rc522.c,382 :: 		n = 1;
	MOVLW       1
	MOVWF       MFRC522_ToCard_n_L0+0 
L_MFRC522_ToCard28:
;rc522.c,383 :: 		if (n > MAX_LEN)
	MOVF        MFRC522_ToCard_n_L0+0, 0 
	SUBLW       16
	BTFSC       STATUS+0, 0 
	GOTO        L_MFRC522_ToCard29
;rc522.c,384 :: 		n = MAX_LEN;
	MOVLW       16
	MOVWF       MFRC522_ToCard_n_L0+0 
L_MFRC522_ToCard29:
;rc522.c,387 :: 		for (i=0; i<n; i++)
	CLRF        MFRC522_ToCard_i_L0+0 
L_MFRC522_ToCard30:
	MOVF        MFRC522_ToCard_n_L0+0, 0 
	SUBWF       MFRC522_ToCard_i_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_MFRC522_ToCard31
;rc522.c,388 :: 		backData[i] = Read_MFRC522(FIFODataReg);
	MOVF        MFRC522_ToCard_i_L0+0, 0 
	ADDWF       FARG_MFRC522_ToCard_backData+0, 0 
	MOVWF       FLOC__MFRC522_ToCard+0 
	MOVLW       0
	ADDWFC      FARG_MFRC522_ToCard_backData+1, 0 
	MOVWF       FLOC__MFRC522_ToCard+1 
	MOVLW       9
	MOVWF       FARG_Read_MFRC522_addr+0 
	CALL        _Read_MFRC522+0, 0
	MOVFF       FLOC__MFRC522_ToCard+0, FSR1L+0
	MOVFF       FLOC__MFRC522_ToCard+1, FSR1H+0
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
;rc522.c,387 :: 		for (i=0; i<n; i++)
	INCF        MFRC522_ToCard_i_L0+0, 1 
;rc522.c,388 :: 		backData[i] = Read_MFRC522(FIFODataReg);
	GOTO        L_MFRC522_ToCard30
L_MFRC522_ToCard31:
;rc522.c,389 :: 		}
L_MFRC522_ToCard25:
;rc522.c,390 :: 		}
	GOTO        L_MFRC522_ToCard33
L_MFRC522_ToCard23:
;rc522.c,392 :: 		status = MI_ERR;
	MOVLW       2
	MOVWF       MFRC522_ToCard_status_L0+0 
L_MFRC522_ToCard33:
;rc522.c,393 :: 		}
L_MFRC522_ToCard22:
;rc522.c,394 :: 		return status;
	MOVF        MFRC522_ToCard_status_L0+0, 0 
	MOVWF       R0 
;rc522.c,395 :: 		}
L_end_MFRC522_ToCard:
	RETURN      0
; end of _MFRC522_ToCard

_MFRC522_Anticoll:

;rc522.c,404 :: 		unsigned char MFRC522_Anticoll(unsigned char *serNum){
;rc522.c,407 :: 		unsigned char serNumCheck=0;
	CLRF        MFRC522_Anticoll_serNumCheck_L0+0 
;rc522.c,413 :: 		Write_MFRC522(BitFramingReg, 0x00);        //TxLastBists = BitFramingReg[2..0]
	MOVLW       13
	MOVWF       FARG_Write_MFRC522_addr+0 
	CLRF        FARG_Write_MFRC522_val+0 
	CALL        _Write_MFRC522+0, 0
;rc522.c,415 :: 		serNum[0] = PICC_ANTICOLL;
	MOVFF       FARG_MFRC522_Anticoll_serNum+0, FSR1L+0
	MOVFF       FARG_MFRC522_Anticoll_serNum+1, FSR1H+0
	MOVLW       147
	MOVWF       POSTINC1+0 
;rc522.c,416 :: 		serNum[1] = 0x20;
	MOVLW       1
	ADDWF       FARG_MFRC522_Anticoll_serNum+0, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      FARG_MFRC522_Anticoll_serNum+1, 0 
	MOVWF       FSR1L+1 
	MOVLW       32
	MOVWF       POSTINC1+0 
;rc522.c,417 :: 		status = MFRC522_ToCard(PCD_TRANSCEIVE, serNum, 2, serNum, &unLen);
	MOVLW       12
	MOVWF       FARG_MFRC522_ToCard_command+0 
	MOVF        FARG_MFRC522_Anticoll_serNum+0, 0 
	MOVWF       FARG_MFRC522_ToCard_sendData+0 
	MOVF        FARG_MFRC522_Anticoll_serNum+1, 0 
	MOVWF       FARG_MFRC522_ToCard_sendData+1 
	MOVLW       2
	MOVWF       FARG_MFRC522_ToCard_sendLen+0 
	MOVF        FARG_MFRC522_Anticoll_serNum+0, 0 
	MOVWF       FARG_MFRC522_ToCard_backData+0 
	MOVF        FARG_MFRC522_Anticoll_serNum+1, 0 
	MOVWF       FARG_MFRC522_ToCard_backData+1 
	MOVLW       MFRC522_Anticoll_unLen_L0+0
	MOVWF       FARG_MFRC522_ToCard_backLen+0 
	MOVLW       hi_addr(MFRC522_Anticoll_unLen_L0+0)
	MOVWF       FARG_MFRC522_ToCard_backLen+1 
	CALL        _MFRC522_ToCard+0, 0
	MOVF        R0, 0 
	MOVWF       MFRC522_Anticoll_status_L0+0 
;rc522.c,419 :: 		if (status == MI_OK){
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_MFRC522_Anticoll34
;rc522.c,421 :: 		for (i=0; i<4; i++)
	CLRF        MFRC522_Anticoll_i_L0+0 
L_MFRC522_Anticoll35:
	MOVLW       4
	SUBWF       MFRC522_Anticoll_i_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_MFRC522_Anticoll36
;rc522.c,422 :: 		serNumCheck ^= serNum[i];
	MOVF        MFRC522_Anticoll_i_L0+0, 0 
	ADDWF       FARG_MFRC522_Anticoll_serNum+0, 0 
	MOVWF       FSR2L+0 
	MOVLW       0
	ADDWFC      FARG_MFRC522_Anticoll_serNum+1, 0 
	MOVWF       FSR2L+1 
	MOVF        POSTINC2+0, 0 
	XORWF       MFRC522_Anticoll_serNumCheck_L0+0, 1 
;rc522.c,421 :: 		for (i=0; i<4; i++)
	INCF        MFRC522_Anticoll_i_L0+0, 1 
;rc522.c,422 :: 		serNumCheck ^= serNum[i];
	GOTO        L_MFRC522_Anticoll35
L_MFRC522_Anticoll36:
;rc522.c,424 :: 		if (serNumCheck != serNum[i])
	MOVF        MFRC522_Anticoll_i_L0+0, 0 
	ADDWF       FARG_MFRC522_Anticoll_serNum+0, 0 
	MOVWF       FSR2L+0 
	MOVLW       0
	ADDWFC      FARG_MFRC522_Anticoll_serNum+1, 0 
	MOVWF       FSR2L+1 
	MOVF        MFRC522_Anticoll_serNumCheck_L0+0, 0 
	XORWF       POSTINC2+0, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L_MFRC522_Anticoll38
;rc522.c,425 :: 		status = MI_ERR;
	MOVLW       2
	MOVWF       MFRC522_Anticoll_status_L0+0 
L_MFRC522_Anticoll38:
;rc522.c,426 :: 		}
L_MFRC522_Anticoll34:
;rc522.c,430 :: 		return status;
	MOVF        MFRC522_Anticoll_status_L0+0, 0 
	MOVWF       R0 
;rc522.c,431 :: 		}
L_end_MFRC522_Anticoll:
	RETURN      0
; end of _MFRC522_Anticoll

_CalulateCRC:

;rc522.c,438 :: 		void CalulateCRC(unsigned char *pIndata, unsigned char len, unsigned char *pOutData){
;rc522.c,441 :: 		ClearBitMask(DivIrqReg, 0x04);                        //CRCIrq = 0
	MOVLW       5
	MOVWF       FARG_ClearBitMask_reg+0 
	MOVLW       4
	MOVWF       FARG_ClearBitMask_mask+0 
	CALL        _ClearBitMask+0, 0
;rc522.c,442 :: 		SetBitMask(FIFOLevelReg, 0x80);                        //Clear the FIFO pointer
	MOVLW       10
	MOVWF       FARG_SetBitMask_reg+0 
	MOVLW       128
	MOVWF       FARG_SetBitMask_mask+0 
	CALL        _SetBitMask+0, 0
;rc522.c,446 :: 		for (i=0; i<len; i++)
	CLRF        CalulateCRC_i_L0+0 
L_CalulateCRC39:
	MOVF        FARG_CalulateCRC_len+0, 0 
	SUBWF       CalulateCRC_i_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_CalulateCRC40
;rc522.c,447 :: 		Write_MFRC522(FIFODataReg, *(pIndata+i));
	MOVLW       9
	MOVWF       FARG_Write_MFRC522_addr+0 
	MOVF        CalulateCRC_i_L0+0, 0 
	ADDWF       FARG_CalulateCRC_pIndata+0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      FARG_CalulateCRC_pIndata+1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Write_MFRC522_val+0 
	CALL        _Write_MFRC522+0, 0
;rc522.c,446 :: 		for (i=0; i<len; i++)
	INCF        CalulateCRC_i_L0+0, 1 
;rc522.c,447 :: 		Write_MFRC522(FIFODataReg, *(pIndata+i));
	GOTO        L_CalulateCRC39
L_CalulateCRC40:
;rc522.c,449 :: 		Write_MFRC522(CommandReg, PCD_CALCCRC);
	MOVLW       1
	MOVWF       FARG_Write_MFRC522_addr+0 
	MOVLW       3
	MOVWF       FARG_Write_MFRC522_val+0 
	CALL        _Write_MFRC522+0, 0
;rc522.c,452 :: 		i = 0xFF;
	MOVLW       255
	MOVWF       CalulateCRC_i_L0+0 
;rc522.c,453 :: 		do{
L_CalulateCRC42:
;rc522.c,454 :: 		n = Read_MFRC522(DivIrqReg);
	MOVLW       5
	MOVWF       FARG_Read_MFRC522_addr+0 
	CALL        _Read_MFRC522+0, 0
	MOVF        R0, 0 
	MOVWF       CalulateCRC_n_L0+0 
;rc522.c,455 :: 		i--;
	DECF        CalulateCRC_i_L0+0, 1 
;rc522.c,457 :: 		while ((i!=0) && !(n&0x04));                        //CRCIrq = 1
	MOVF        CalulateCRC_i_L0+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L__CalulateCRC99
	BTFSC       CalulateCRC_n_L0+0, 2 
	GOTO        L__CalulateCRC99
	GOTO        L_CalulateCRC42
L__CalulateCRC99:
;rc522.c,460 :: 		pOutData[0] = Read_MFRC522(CRCResultRegL);
	MOVF        FARG_CalulateCRC_pOutData+0, 0 
	MOVWF       FLOC__CalulateCRC+0 
	MOVF        FARG_CalulateCRC_pOutData+1, 0 
	MOVWF       FLOC__CalulateCRC+1 
	MOVLW       34
	MOVWF       FARG_Read_MFRC522_addr+0 
	CALL        _Read_MFRC522+0, 0
	MOVFF       FLOC__CalulateCRC+0, FSR1L+0
	MOVFF       FLOC__CalulateCRC+1, FSR1H+0
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
;rc522.c,461 :: 		pOutData[1] = Read_MFRC522(CRCResultRegM);
	MOVLW       1
	ADDWF       FARG_CalulateCRC_pOutData+0, 0 
	MOVWF       FLOC__CalulateCRC+0 
	MOVLW       0
	ADDWFC      FARG_CalulateCRC_pOutData+1, 0 
	MOVWF       FLOC__CalulateCRC+1 
	MOVLW       33
	MOVWF       FARG_Read_MFRC522_addr+0 
	CALL        _Read_MFRC522+0, 0
	MOVFF       FLOC__CalulateCRC+0, FSR1L+0
	MOVFF       FLOC__CalulateCRC+1, FSR1H+0
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
;rc522.c,462 :: 		}
L_end_CalulateCRC:
	RETURN      0
; end of _CalulateCRC

_MFRC522_SelectTag:

;rc522.c,469 :: 		unsigned char MFRC522_SelectTag(unsigned char *serNum){
;rc522.c,478 :: 		buffer[0] = PICC_SElECTTAG;
	MOVLW       147
	MOVWF       MFRC522_SelectTag_buffer_L0+0 
;rc522.c,479 :: 		buffer[1] = 0x70;
	MOVLW       112
	MOVWF       MFRC522_SelectTag_buffer_L0+1 
;rc522.c,480 :: 		for (i=0; i<5; i++)
	CLRF        MFRC522_SelectTag_i_L0+0 
L_MFRC522_SelectTag47:
	MOVLW       5
	SUBWF       MFRC522_SelectTag_i_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_MFRC522_SelectTag48
;rc522.c,481 :: 		buffer[i+2] = *(serNum+i);
	MOVLW       2
	ADDWF       MFRC522_SelectTag_i_L0+0, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVLW       0
	ADDWFC      R1, 1 
	MOVLW       MFRC522_SelectTag_buffer_L0+0
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       hi_addr(MFRC522_SelectTag_buffer_L0+0)
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	MOVF        MFRC522_SelectTag_i_L0+0, 0 
	ADDWF       FARG_MFRC522_SelectTag_serNum+0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      FARG_MFRC522_SelectTag_serNum+1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
;rc522.c,480 :: 		for (i=0; i<5; i++)
	INCF        MFRC522_SelectTag_i_L0+0, 1 
;rc522.c,481 :: 		buffer[i+2] = *(serNum+i);
	GOTO        L_MFRC522_SelectTag47
L_MFRC522_SelectTag48:
;rc522.c,483 :: 		CalulateCRC(buffer, 7, &buffer[7]);                //??
	MOVLW       MFRC522_SelectTag_buffer_L0+0
	MOVWF       FARG_CalulateCRC_pIndata+0 
	MOVLW       hi_addr(MFRC522_SelectTag_buffer_L0+0)
	MOVWF       FARG_CalulateCRC_pIndata+1 
	MOVLW       7
	MOVWF       FARG_CalulateCRC_len+0 
	MOVLW       MFRC522_SelectTag_buffer_L0+7
	MOVWF       FARG_CalulateCRC_pOutData+0 
	MOVLW       hi_addr(MFRC522_SelectTag_buffer_L0+7)
	MOVWF       FARG_CalulateCRC_pOutData+1 
	CALL        _CalulateCRC+0, 0
;rc522.c,484 :: 		status = MFRC522_ToCard(PCD_TRANSCEIVE, buffer, 9, buffer, &recvBits);
	MOVLW       12
	MOVWF       FARG_MFRC522_ToCard_command+0 
	MOVLW       MFRC522_SelectTag_buffer_L0+0
	MOVWF       FARG_MFRC522_ToCard_sendData+0 
	MOVLW       hi_addr(MFRC522_SelectTag_buffer_L0+0)
	MOVWF       FARG_MFRC522_ToCard_sendData+1 
	MOVLW       9
	MOVWF       FARG_MFRC522_ToCard_sendLen+0 
	MOVLW       MFRC522_SelectTag_buffer_L0+0
	MOVWF       FARG_MFRC522_ToCard_backData+0 
	MOVLW       hi_addr(MFRC522_SelectTag_buffer_L0+0)
	MOVWF       FARG_MFRC522_ToCard_backData+1 
	MOVLW       MFRC522_SelectTag_recvBits_L0+0
	MOVWF       FARG_MFRC522_ToCard_backLen+0 
	MOVLW       hi_addr(MFRC522_SelectTag_recvBits_L0+0)
	MOVWF       FARG_MFRC522_ToCard_backLen+1 
	CALL        _MFRC522_ToCard+0, 0
;rc522.c,486 :: 		if ((status == MI_OK) && (recvBits == 0x18))
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_MFRC522_SelectTag52
	MOVF        MFRC522_SelectTag_recvBits_L0+0, 0 
	XORLW       24
	BTFSS       STATUS+0, 2 
	GOTO        L_MFRC522_SelectTag52
L__MFRC522_SelectTag100:
;rc522.c,487 :: 		size = buffer[0];
	MOVF        MFRC522_SelectTag_buffer_L0+0, 0 
	MOVWF       MFRC522_SelectTag_size_L0+0 
	GOTO        L_MFRC522_SelectTag53
L_MFRC522_SelectTag52:
;rc522.c,489 :: 		size = 0;
	CLRF        MFRC522_SelectTag_size_L0+0 
L_MFRC522_SelectTag53:
;rc522.c,491 :: 		return size;
	MOVF        MFRC522_SelectTag_size_L0+0, 0 
	MOVWF       R0 
;rc522.c,492 :: 		}
L_end_MFRC522_SelectTag:
	RETURN      0
; end of _MFRC522_SelectTag

_MFRC522_Auth:

;rc522.c,504 :: 		unsigned char MFRC522_Auth(unsigned char authMode, unsigned char BlockAddr, unsigned char *Sectorkey, unsigned char *serNum){
;rc522.c,511 :: 		buff[0] = authMode;
	MOVF        FARG_MFRC522_Auth_authMode+0, 0 
	MOVWF       MFRC522_Auth_buff_L0+0 
;rc522.c,512 :: 		buff[1] = BlockAddr;
	MOVF        FARG_MFRC522_Auth_BlockAddr+0, 0 
	MOVWF       MFRC522_Auth_buff_L0+1 
;rc522.c,513 :: 		for (i=0; i<6; i++)
	CLRF        MFRC522_Auth_i_L0+0 
L_MFRC522_Auth54:
	MOVLW       6
	SUBWF       MFRC522_Auth_i_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_MFRC522_Auth55
;rc522.c,514 :: 		buff[i+2] = *(Sectorkey+i);
	MOVLW       2
	ADDWF       MFRC522_Auth_i_L0+0, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVLW       0
	ADDWFC      R1, 1 
	MOVLW       MFRC522_Auth_buff_L0+0
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       hi_addr(MFRC522_Auth_buff_L0+0)
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	MOVF        MFRC522_Auth_i_L0+0, 0 
	ADDWF       FARG_MFRC522_Auth_Sectorkey+0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      FARG_MFRC522_Auth_Sectorkey+1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
;rc522.c,513 :: 		for (i=0; i<6; i++)
	INCF        MFRC522_Auth_i_L0+0, 1 
;rc522.c,514 :: 		buff[i+2] = *(Sectorkey+i);
	GOTO        L_MFRC522_Auth54
L_MFRC522_Auth55:
;rc522.c,516 :: 		for (i=0; i<4; i++)
	CLRF        MFRC522_Auth_i_L0+0 
L_MFRC522_Auth57:
	MOVLW       4
	SUBWF       MFRC522_Auth_i_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_MFRC522_Auth58
;rc522.c,517 :: 		buff[i+8] = *(serNum+i);
	MOVLW       8
	ADDWF       MFRC522_Auth_i_L0+0, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVLW       0
	ADDWFC      R1, 1 
	MOVLW       MFRC522_Auth_buff_L0+0
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       hi_addr(MFRC522_Auth_buff_L0+0)
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	MOVF        MFRC522_Auth_i_L0+0, 0 
	ADDWF       FARG_MFRC522_Auth_serNum+0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      FARG_MFRC522_Auth_serNum+1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
;rc522.c,516 :: 		for (i=0; i<4; i++)
	INCF        MFRC522_Auth_i_L0+0, 1 
;rc522.c,517 :: 		buff[i+8] = *(serNum+i);
	GOTO        L_MFRC522_Auth57
L_MFRC522_Auth58:
;rc522.c,519 :: 		status = MFRC522_ToCard(PCD_AUTHENT, buff, 12, buff, &recvBits);
	MOVLW       14
	MOVWF       FARG_MFRC522_ToCard_command+0 
	MOVLW       MFRC522_Auth_buff_L0+0
	MOVWF       FARG_MFRC522_ToCard_sendData+0 
	MOVLW       hi_addr(MFRC522_Auth_buff_L0+0)
	MOVWF       FARG_MFRC522_ToCard_sendData+1 
	MOVLW       12
	MOVWF       FARG_MFRC522_ToCard_sendLen+0 
	MOVLW       MFRC522_Auth_buff_L0+0
	MOVWF       FARG_MFRC522_ToCard_backData+0 
	MOVLW       hi_addr(MFRC522_Auth_buff_L0+0)
	MOVWF       FARG_MFRC522_ToCard_backData+1 
	MOVLW       MFRC522_Auth_recvBits_L0+0
	MOVWF       FARG_MFRC522_ToCard_backLen+0 
	MOVLW       hi_addr(MFRC522_Auth_recvBits_L0+0)
	MOVWF       FARG_MFRC522_ToCard_backLen+1 
	CALL        _MFRC522_ToCard+0, 0
	MOVF        R0, 0 
	MOVWF       MFRC522_Auth_status_L0+0 
;rc522.c,521 :: 		if ((status != MI_OK) || (!(Read_MFRC522(Status2Reg) & 0x08)))
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__MFRC522_Auth101
	MOVLW       8
	MOVWF       FARG_Read_MFRC522_addr+0 
	CALL        _Read_MFRC522+0, 0
	BTFSS       R0, 3 
	GOTO        L__MFRC522_Auth101
	GOTO        L_MFRC522_Auth62
L__MFRC522_Auth101:
;rc522.c,522 :: 		status = MI_ERR;
	MOVLW       2
	MOVWF       MFRC522_Auth_status_L0+0 
L_MFRC522_Auth62:
;rc522.c,524 :: 		return status;
	MOVF        MFRC522_Auth_status_L0+0, 0 
	MOVWF       R0 
;rc522.c,525 :: 		}
L_end_MFRC522_Auth:
	RETURN      0
; end of _MFRC522_Auth

_MFRC522_Read:

;rc522.c,532 :: 		unsigned char MFRC522_Read(unsigned char blockAddr, unsigned char *recvData){
;rc522.c,536 :: 		recvData[0] = PICC_READ;
	MOVFF       FARG_MFRC522_Read_recvData+0, FSR1L+0
	MOVFF       FARG_MFRC522_Read_recvData+1, FSR1H+0
	MOVLW       48
	MOVWF       POSTINC1+0 
;rc522.c,537 :: 		recvData[1] = blockAddr;
	MOVLW       1
	ADDWF       FARG_MFRC522_Read_recvData+0, 0 
	MOVWF       FSR1L+0 
	MOVLW       0
	ADDWFC      FARG_MFRC522_Read_recvData+1, 0 
	MOVWF       FSR1L+1 
	MOVF        FARG_MFRC522_Read_blockAddr+0, 0 
	MOVWF       POSTINC1+0 
;rc522.c,538 :: 		CalulateCRC(recvData,2, &recvData[2]);
	MOVF        FARG_MFRC522_Read_recvData+0, 0 
	MOVWF       FARG_CalulateCRC_pIndata+0 
	MOVF        FARG_MFRC522_Read_recvData+1, 0 
	MOVWF       FARG_CalulateCRC_pIndata+1 
	MOVLW       2
	MOVWF       FARG_CalulateCRC_len+0 
	MOVLW       2
	ADDWF       FARG_MFRC522_Read_recvData+0, 0 
	MOVWF       FARG_CalulateCRC_pOutData+0 
	MOVLW       0
	ADDWFC      FARG_MFRC522_Read_recvData+1, 0 
	MOVWF       FARG_CalulateCRC_pOutData+1 
	CALL        _CalulateCRC+0, 0
;rc522.c,539 :: 		status = MFRC522_ToCard(PCD_TRANSCEIVE, recvData, 4, recvData, &unLen);
	MOVLW       12
	MOVWF       FARG_MFRC522_ToCard_command+0 
	MOVF        FARG_MFRC522_Read_recvData+0, 0 
	MOVWF       FARG_MFRC522_ToCard_sendData+0 
	MOVF        FARG_MFRC522_Read_recvData+1, 0 
	MOVWF       FARG_MFRC522_ToCard_sendData+1 
	MOVLW       4
	MOVWF       FARG_MFRC522_ToCard_sendLen+0 
	MOVF        FARG_MFRC522_Read_recvData+0, 0 
	MOVWF       FARG_MFRC522_ToCard_backData+0 
	MOVF        FARG_MFRC522_Read_recvData+1, 0 
	MOVWF       FARG_MFRC522_ToCard_backData+1 
	MOVLW       MFRC522_Read_unLen_L0+0
	MOVWF       FARG_MFRC522_ToCard_backLen+0 
	MOVLW       hi_addr(MFRC522_Read_unLen_L0+0)
	MOVWF       FARG_MFRC522_ToCard_backLen+1 
	CALL        _MFRC522_ToCard+0, 0
	MOVF        R0, 0 
	MOVWF       MFRC522_Read_status_L0+0 
;rc522.c,541 :: 		if ((status != MI_OK) || (unLen != 0x90))
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__MFRC522_Read102
	MOVLW       0
	XORWF       MFRC522_Read_unLen_L0+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__MFRC522_Read126
	MOVLW       144
	XORWF       MFRC522_Read_unLen_L0+0, 0 
L__MFRC522_Read126:
	BTFSS       STATUS+0, 2 
	GOTO        L__MFRC522_Read102
	GOTO        L_MFRC522_Read65
L__MFRC522_Read102:
;rc522.c,542 :: 		status = MI_ERR;
	MOVLW       2
	MOVWF       MFRC522_Read_status_L0+0 
L_MFRC522_Read65:
;rc522.c,544 :: 		return status;
	MOVF        MFRC522_Read_status_L0+0, 0 
	MOVWF       R0 
;rc522.c,545 :: 		}
L_end_MFRC522_Read:
	RETURN      0
; end of _MFRC522_Read

_MFRC522_Write:

;rc522.c,552 :: 		unsigned char MFRC522_Write(unsigned char blockAddr, unsigned char *writeData){
;rc522.c,558 :: 		buff[0] = PICC_WRITE;
	MOVLW       160
	MOVWF       MFRC522_Write_buff_L0+0 
;rc522.c,559 :: 		buff[1] = blockAddr;
	MOVF        FARG_MFRC522_Write_blockAddr+0, 0 
	MOVWF       MFRC522_Write_buff_L0+1 
;rc522.c,560 :: 		CalulateCRC(buff, 2, &buff[2]);
	MOVLW       MFRC522_Write_buff_L0+0
	MOVWF       FARG_CalulateCRC_pIndata+0 
	MOVLW       hi_addr(MFRC522_Write_buff_L0+0)
	MOVWF       FARG_CalulateCRC_pIndata+1 
	MOVLW       2
	MOVWF       FARG_CalulateCRC_len+0 
	MOVLW       MFRC522_Write_buff_L0+2
	MOVWF       FARG_CalulateCRC_pOutData+0 
	MOVLW       hi_addr(MFRC522_Write_buff_L0+2)
	MOVWF       FARG_CalulateCRC_pOutData+1 
	CALL        _CalulateCRC+0, 0
;rc522.c,561 :: 		status = MFRC522_ToCard(PCD_TRANSCEIVE, buff, 4, buff, &recvBits);
	MOVLW       12
	MOVWF       FARG_MFRC522_ToCard_command+0 
	MOVLW       MFRC522_Write_buff_L0+0
	MOVWF       FARG_MFRC522_ToCard_sendData+0 
	MOVLW       hi_addr(MFRC522_Write_buff_L0+0)
	MOVWF       FARG_MFRC522_ToCard_sendData+1 
	MOVLW       4
	MOVWF       FARG_MFRC522_ToCard_sendLen+0 
	MOVLW       MFRC522_Write_buff_L0+0
	MOVWF       FARG_MFRC522_ToCard_backData+0 
	MOVLW       hi_addr(MFRC522_Write_buff_L0+0)
	MOVWF       FARG_MFRC522_ToCard_backData+1 
	MOVLW       MFRC522_Write_recvBits_L0+0
	MOVWF       FARG_MFRC522_ToCard_backLen+0 
	MOVLW       hi_addr(MFRC522_Write_recvBits_L0+0)
	MOVWF       FARG_MFRC522_ToCard_backLen+1 
	CALL        _MFRC522_ToCard+0, 0
	MOVF        R0, 0 
	MOVWF       MFRC522_Write_status_L0+0 
;rc522.c,563 :: 		if ((status != MI_OK) || (recvBits != 4) || ((buff[0] & 0x0F) != 0x0A))
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__MFRC522_Write104
	MOVLW       0
	XORWF       MFRC522_Write_recvBits_L0+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__MFRC522_Write128
	MOVLW       4
	XORWF       MFRC522_Write_recvBits_L0+0, 0 
L__MFRC522_Write128:
	BTFSS       STATUS+0, 2 
	GOTO        L__MFRC522_Write104
	MOVLW       15
	ANDWF       MFRC522_Write_buff_L0+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	XORLW       10
	BTFSS       STATUS+0, 2 
	GOTO        L__MFRC522_Write104
	GOTO        L_MFRC522_Write68
L__MFRC522_Write104:
;rc522.c,564 :: 		status = MI_ERR;
	MOVLW       2
	MOVWF       MFRC522_Write_status_L0+0 
L_MFRC522_Write68:
;rc522.c,566 :: 		if (status == MI_OK)
	MOVF        MFRC522_Write_status_L0+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_MFRC522_Write69
;rc522.c,568 :: 		for (i=0; i<16; i++)                //Data to the FIFO write 16Byte
	CLRF        MFRC522_Write_i_L0+0 
L_MFRC522_Write70:
	MOVLW       16
	SUBWF       MFRC522_Write_i_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_MFRC522_Write71
;rc522.c,569 :: 		buff[i] = *(writeData+i);
	MOVLW       MFRC522_Write_buff_L0+0
	MOVWF       FSR1L+0 
	MOVLW       hi_addr(MFRC522_Write_buff_L0+0)
	MOVWF       FSR1L+1 
	MOVF        MFRC522_Write_i_L0+0, 0 
	ADDWF       FSR1L+0, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR1L+1, 1 
	MOVF        MFRC522_Write_i_L0+0, 0 
	ADDWF       FARG_MFRC522_Write_writeData+0, 0 
	MOVWF       FSR0L+0 
	MOVLW       0
	ADDWFC      FARG_MFRC522_Write_writeData+1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
;rc522.c,568 :: 		for (i=0; i<16; i++)                //Data to the FIFO write 16Byte
	INCF        MFRC522_Write_i_L0+0, 1 
;rc522.c,569 :: 		buff[i] = *(writeData+i);
	GOTO        L_MFRC522_Write70
L_MFRC522_Write71:
;rc522.c,571 :: 		CalulateCRC(buff, 16, &buff[16]);
	MOVLW       MFRC522_Write_buff_L0+0
	MOVWF       FARG_CalulateCRC_pIndata+0 
	MOVLW       hi_addr(MFRC522_Write_buff_L0+0)
	MOVWF       FARG_CalulateCRC_pIndata+1 
	MOVLW       16
	MOVWF       FARG_CalulateCRC_len+0 
	MOVLW       MFRC522_Write_buff_L0+16
	MOVWF       FARG_CalulateCRC_pOutData+0 
	MOVLW       hi_addr(MFRC522_Write_buff_L0+16)
	MOVWF       FARG_CalulateCRC_pOutData+1 
	CALL        _CalulateCRC+0, 0
;rc522.c,572 :: 		status = MFRC522_ToCard(PCD_TRANSCEIVE, buff, 18, buff, &recvBits);
	MOVLW       12
	MOVWF       FARG_MFRC522_ToCard_command+0 
	MOVLW       MFRC522_Write_buff_L0+0
	MOVWF       FARG_MFRC522_ToCard_sendData+0 
	MOVLW       hi_addr(MFRC522_Write_buff_L0+0)
	MOVWF       FARG_MFRC522_ToCard_sendData+1 
	MOVLW       18
	MOVWF       FARG_MFRC522_ToCard_sendLen+0 
	MOVLW       MFRC522_Write_buff_L0+0
	MOVWF       FARG_MFRC522_ToCard_backData+0 
	MOVLW       hi_addr(MFRC522_Write_buff_L0+0)
	MOVWF       FARG_MFRC522_ToCard_backData+1 
	MOVLW       MFRC522_Write_recvBits_L0+0
	MOVWF       FARG_MFRC522_ToCard_backLen+0 
	MOVLW       hi_addr(MFRC522_Write_recvBits_L0+0)
	MOVWF       FARG_MFRC522_ToCard_backLen+1 
	CALL        _MFRC522_ToCard+0, 0
	MOVF        R0, 0 
	MOVWF       MFRC522_Write_status_L0+0 
;rc522.c,574 :: 		if ((status != MI_OK) || (recvBits != 4) || ((buff[0] & 0x0F) != 0x0A))
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__MFRC522_Write103
	MOVLW       0
	XORWF       MFRC522_Write_recvBits_L0+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__MFRC522_Write129
	MOVLW       4
	XORWF       MFRC522_Write_recvBits_L0+0, 0 
L__MFRC522_Write129:
	BTFSS       STATUS+0, 2 
	GOTO        L__MFRC522_Write103
	MOVLW       15
	ANDWF       MFRC522_Write_buff_L0+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	XORLW       10
	BTFSS       STATUS+0, 2 
	GOTO        L__MFRC522_Write103
	GOTO        L_MFRC522_Write75
L__MFRC522_Write103:
;rc522.c,575 :: 		status = MI_ERR;
	MOVLW       2
	MOVWF       MFRC522_Write_status_L0+0 
L_MFRC522_Write75:
;rc522.c,576 :: 		}
L_MFRC522_Write69:
;rc522.c,578 :: 		return status;
	MOVF        MFRC522_Write_status_L0+0, 0 
	MOVWF       R0 
;rc522.c,579 :: 		}
L_end_MFRC522_Write:
	RETURN      0
; end of _MFRC522_Write

_MFRC522_Halt:

;rc522.c,586 :: 		void MFRC522_Halt(void){
;rc522.c,591 :: 		buff[0] = PICC_HALT;
	MOVLW       80
	MOVWF       MFRC522_Halt_buff_L0+0 
;rc522.c,592 :: 		buff[1] = 0;
	CLRF        MFRC522_Halt_buff_L0+1 
;rc522.c,593 :: 		CalulateCRC(buff, 2, &buff[2]);
	MOVLW       MFRC522_Halt_buff_L0+0
	MOVWF       FARG_CalulateCRC_pIndata+0 
	MOVLW       hi_addr(MFRC522_Halt_buff_L0+0)
	MOVWF       FARG_CalulateCRC_pIndata+1 
	MOVLW       2
	MOVWF       FARG_CalulateCRC_len+0 
	MOVLW       MFRC522_Halt_buff_L0+2
	MOVWF       FARG_CalulateCRC_pOutData+0 
	MOVLW       hi_addr(MFRC522_Halt_buff_L0+2)
	MOVWF       FARG_CalulateCRC_pOutData+1 
	CALL        _CalulateCRC+0, 0
;rc522.c,595 :: 		status = MFRC522_ToCard(PCD_TRANSCEIVE, buff, 4, buff,&unLen);
	MOVLW       12
	MOVWF       FARG_MFRC522_ToCard_command+0 
	MOVLW       MFRC522_Halt_buff_L0+0
	MOVWF       FARG_MFRC522_ToCard_sendData+0 
	MOVLW       hi_addr(MFRC522_Halt_buff_L0+0)
	MOVWF       FARG_MFRC522_ToCard_sendData+1 
	MOVLW       4
	MOVWF       FARG_MFRC522_ToCard_sendLen+0 
	MOVLW       MFRC522_Halt_buff_L0+0
	MOVWF       FARG_MFRC522_ToCard_backData+0 
	MOVLW       hi_addr(MFRC522_Halt_buff_L0+0)
	MOVWF       FARG_MFRC522_ToCard_backData+1 
	MOVLW       MFRC522_Halt_unLen_L0+0
	MOVWF       FARG_MFRC522_ToCard_backLen+0 
	MOVLW       hi_addr(MFRC522_Halt_unLen_L0+0)
	MOVWF       FARG_MFRC522_ToCard_backLen+1 
	CALL        _MFRC522_ToCard+0, 0
;rc522.c,596 :: 		}
L_end_MFRC522_Halt:
	RETURN      0
; end of _MFRC522_Halt

_MFRC522_GetId:

;rc522.c,598 :: 		unsigned long MFRC522_GetId(){
;rc522.c,601 :: 		unsigned long id=0;
	CLRF        MFRC522_GetId_id_L0+0 
	CLRF        MFRC522_GetId_id_L0+1 
	CLRF        MFRC522_GetId_id_L0+2 
	CLRF        MFRC522_GetId_id_L0+3 
;rc522.c,604 :: 		response = MFRC522_Request(PICC_REQIDL, str);
	MOVLW       38
	MOVWF       FARG_MFRC522_Request_reqMode+0 
	MOVLW       MFRC522_GetId_str_L0+0
	MOVWF       FARG_MFRC522_Request_TagType+0 
	MOVLW       hi_addr(MFRC522_GetId_str_L0+0)
	MOVWF       FARG_MFRC522_Request_TagType+1 
	CALL        _MFRC522_Request+0, 0
	MOVF        R0, 0 
	MOVWF       MFRC522_GetId_response_L0+0 
;rc522.c,606 :: 		response = MFRC522_Anticoll(str);
	MOVLW       MFRC522_GetId_str_L0+0
	MOVWF       FARG_MFRC522_Anticoll_serNum+0 
	MOVLW       hi_addr(MFRC522_GetId_str_L0+0)
	MOVWF       FARG_MFRC522_Anticoll_serNum+1 
	CALL        _MFRC522_Anticoll+0, 0
	MOVF        R0, 0 
	MOVWF       MFRC522_GetId_response_L0+0 
;rc522.c,607 :: 		memcpy(serNum, str, 5);
	MOVLW       _serNum+0
	MOVWF       FARG_memcpy_d1+0 
	MOVLW       hi_addr(_serNum+0)
	MOVWF       FARG_memcpy_d1+1 
	MOVLW       MFRC522_GetId_str_L0+0
	MOVWF       FARG_memcpy_s1+0 
	MOVLW       hi_addr(MFRC522_GetId_str_L0+0)
	MOVWF       FARG_memcpy_s1+1 
	MOVLW       5
	MOVWF       FARG_memcpy_n+0 
	MOVLW       0
	MOVWF       FARG_memcpy_n+1 
	CALL        _memcpy+0, 0
;rc522.c,609 :: 		if (response == MI_OK){   //if ther is a new card detected
	MOVF        MFRC522_GetId_response_L0+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_MFRC522_GetId76
;rc522.c,610 :: 		id  = serNum[0]; id<<=8;
	MOVF        _serNum+0, 0 
	MOVWF       MFRC522_GetId_id_L0+0 
	MOVLW       0
	MOVWF       MFRC522_GetId_id_L0+1 
	MOVWF       MFRC522_GetId_id_L0+2 
	MOVWF       MFRC522_GetId_id_L0+3 
	MOVF        MFRC522_GetId_id_L0+2, 0 
	MOVWF       MFRC522_GetId_id_L0+3 
	MOVF        MFRC522_GetId_id_L0+1, 0 
	MOVWF       MFRC522_GetId_id_L0+2 
	MOVF        MFRC522_GetId_id_L0+0, 0 
	MOVWF       MFRC522_GetId_id_L0+1 
	CLRF        MFRC522_GetId_id_L0+0 
;rc522.c,611 :: 		id += serNum[1]; id<<=8;
	MOVF        _serNum+1, 0 
	ADDWF       MFRC522_GetId_id_L0+0, 1 
	MOVLW       0
	ADDWFC      MFRC522_GetId_id_L0+1, 1 
	ADDWFC      MFRC522_GetId_id_L0+2, 1 
	ADDWFC      MFRC522_GetId_id_L0+3, 1 
	MOVF        MFRC522_GetId_id_L0+2, 0 
	MOVWF       MFRC522_GetId_id_L0+3 
	MOVF        MFRC522_GetId_id_L0+1, 0 
	MOVWF       MFRC522_GetId_id_L0+2 
	MOVF        MFRC522_GetId_id_L0+0, 0 
	MOVWF       MFRC522_GetId_id_L0+1 
	CLRF        MFRC522_GetId_id_L0+0 
;rc522.c,612 :: 		id += serNum[2]; id<<=8;
	MOVF        _serNum+2, 0 
	ADDWF       MFRC522_GetId_id_L0+0, 1 
	MOVLW       0
	ADDWFC      MFRC522_GetId_id_L0+1, 1 
	ADDWFC      MFRC522_GetId_id_L0+2, 1 
	ADDWFC      MFRC522_GetId_id_L0+3, 1 
	MOVF        MFRC522_GetId_id_L0+2, 0 
	MOVWF       MFRC522_GetId_id_L0+3 
	MOVF        MFRC522_GetId_id_L0+1, 0 
	MOVWF       MFRC522_GetId_id_L0+2 
	MOVF        MFRC522_GetId_id_L0+0, 0 
	MOVWF       MFRC522_GetId_id_L0+1 
	CLRF        MFRC522_GetId_id_L0+0 
;rc522.c,613 :: 		id += serNum[3];
	MOVF        _serNum+3, 0 
	ADDWF       MFRC522_GetId_id_L0+0, 1 
	MOVLW       0
	ADDWFC      MFRC522_GetId_id_L0+1, 1 
	ADDWFC      MFRC522_GetId_id_L0+2, 1 
	ADDWFC      MFRC522_GetId_id_L0+3, 1 
;rc522.c,614 :: 		}
	GOTO        L_MFRC522_GetId77
L_MFRC522_GetId76:
;rc522.c,616 :: 		MFRC522_Halt();                     // Command card into hibernation
	CALL        _MFRC522_Halt+0, 0
;rc522.c,617 :: 		delay_ms(50);                       // wait for low consuption
	MOVLW       4
	MOVWF       R11, 0
	MOVLW       12
	MOVWF       R12, 0
	MOVLW       51
	MOVWF       R13, 0
L_MFRC522_GetId78:
	DECFSZ      R13, 1, 1
	BRA         L_MFRC522_GetId78
	DECFSZ      R12, 1, 1
	BRA         L_MFRC522_GetId78
	DECFSZ      R11, 1, 1
	BRA         L_MFRC522_GetId78
	NOP
	NOP
;rc522.c,618 :: 		}
L_MFRC522_GetId77:
;rc522.c,620 :: 		return id;
	MOVF        MFRC522_GetId_id_L0+0, 0 
	MOVWF       R0 
	MOVF        MFRC522_GetId_id_L0+1, 0 
	MOVWF       R1 
	MOVF        MFRC522_GetId_id_L0+2, 0 
	MOVWF       R2 
	MOVF        MFRC522_GetId_id_L0+3, 0 
	MOVWF       R3 
;rc522.c,621 :: 		}
L_end_MFRC522_GetId:
	RETURN      0
; end of _MFRC522_GetId

_LCD_Cmd:

;lcd_i2c.c,35 :: 		void LCD_Cmd(char out_char) {
;lcd_i2c.c,37 :: 		char rs = HEX00;
	CLRF        LCD_Cmd_rs_L0+0 
;lcd_i2c.c,39 :: 		hi_n = out_char & HEXF0;
	MOVLW       240
	ANDWF       FARG_LCD_Cmd_out_char+0, 0 
	MOVWF       LCD_Cmd_hi_n_L0+0 
;lcd_i2c.c,40 :: 		lo_n = (out_char << 4) & HEXF0;
	MOVF        FARG_LCD_Cmd_out_char+0, 0 
	MOVWF       LCD_Cmd_lo_n_L0+0 
	RLCF        LCD_Cmd_lo_n_L0+0, 1 
	BCF         LCD_Cmd_lo_n_L0+0, 0 
	RLCF        LCD_Cmd_lo_n_L0+0, 1 
	BCF         LCD_Cmd_lo_n_L0+0, 0 
	RLCF        LCD_Cmd_lo_n_L0+0, 1 
	BCF         LCD_Cmd_lo_n_L0+0, 0 
	RLCF        LCD_Cmd_lo_n_L0+0, 1 
	BCF         LCD_Cmd_lo_n_L0+0, 0 
	MOVLW       240
	ANDWF       LCD_Cmd_lo_n_L0+0, 1 
;lcd_i2c.c,42 :: 		I2C1_Start();
	CALL        _I2C1_Start+0, 0
;lcd_i2c.c,43 :: 		I2C1_Is_Idle();
	CALL        _I2C1_Is_Idle+0, 0
;lcd_i2c.c,44 :: 		I2C1_Wr(LCD_ADDR);
	MOVLW       78
	MOVWF       FARG_I2C1_Wr_data_+0 
	CALL        _I2C1_Wr+0, 0
;lcd_i2c.c,45 :: 		I2C1_Is_Idle();
	CALL        _I2C1_Is_Idle+0, 0
;lcd_i2c.c,46 :: 		I2C1_Wr(hi_n | rs | HEX04 | HEX08);
	MOVF        LCD_Cmd_rs_L0+0, 0 
	IORWF       LCD_Cmd_hi_n_L0+0, 0 
	MOVWF       FARG_I2C1_Wr_data_+0 
	BSF         FARG_I2C1_Wr_data_+0, 2 
	BSF         FARG_I2C1_Wr_data_+0, 3 
	CALL        _I2C1_Wr+0, 0
;lcd_i2c.c,47 :: 		I2C1_Is_Idle();
	CALL        _I2C1_Is_Idle+0, 0
;lcd_i2c.c,48 :: 		Delay_50us();
	CALL        _Delay_50us+0, 0
;lcd_i2c.c,49 :: 		I2C1_Wr(hi_n | rs | HEX00 | HEX08);
	MOVF        LCD_Cmd_rs_L0+0, 0 
	IORWF       LCD_Cmd_hi_n_L0+0, 0 
	MOVWF       FARG_I2C1_Wr_data_+0 
	BSF         FARG_I2C1_Wr_data_+0, 3 
	CALL        _I2C1_Wr+0, 0
;lcd_i2c.c,50 :: 		I2C1_Is_Idle();
	CALL        _I2C1_Is_Idle+0, 0
;lcd_i2c.c,51 :: 		Delay_50us();
	CALL        _Delay_50us+0, 0
;lcd_i2c.c,52 :: 		Delay_50us();
	CALL        _Delay_50us+0, 0
;lcd_i2c.c,53 :: 		I2C1_Wr(lo_n | rs | HEX04 | HEX08);
	MOVF        LCD_Cmd_rs_L0+0, 0 
	IORWF       LCD_Cmd_lo_n_L0+0, 0 
	MOVWF       FARG_I2C1_Wr_data_+0 
	BSF         FARG_I2C1_Wr_data_+0, 2 
	BSF         FARG_I2C1_Wr_data_+0, 3 
	CALL        _I2C1_Wr+0, 0
;lcd_i2c.c,54 :: 		I2C1_Is_Idle();
	CALL        _I2C1_Is_Idle+0, 0
;lcd_i2c.c,55 :: 		Delay_50us();
	CALL        _Delay_50us+0, 0
;lcd_i2c.c,56 :: 		I2C1_Wr(lo_n | rs | HEX00 | HEX08);
	MOVF        LCD_Cmd_rs_L0+0, 0 
	IORWF       LCD_Cmd_lo_n_L0+0, 0 
	MOVWF       FARG_I2C1_Wr_data_+0 
	BSF         FARG_I2C1_Wr_data_+0, 3 
	CALL        _I2C1_Wr+0, 0
;lcd_i2c.c,57 :: 		I2C1_Is_Idle();
	CALL        _I2C1_Is_Idle+0, 0
;lcd_i2c.c,58 :: 		I2C1_stop();
	CALL        _I2C1_Stop+0, 0
;lcd_i2c.c,60 :: 		if(out_char == HEX01)
	MOVF        FARG_LCD_Cmd_out_char+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_LCD_Cmd79
;lcd_i2c.c,61 :: 		Delay_ms(2);
	MOVLW       32
	MOVWF       R12, 0
	MOVLW       41
	MOVWF       R13, 0
L_LCD_Cmd80:
	DECFSZ      R13, 1, 1
	BRA         L_LCD_Cmd80
	DECFSZ      R12, 1, 1
	BRA         L_LCD_Cmd80
	NOP
	NOP
L_LCD_Cmd79:
;lcd_i2c.c,62 :: 		}
L_end_LCD_Cmd:
	RETURN      0
; end of _LCD_Cmd

_LCD_Chr:

;lcd_i2c.c,64 :: 		void LCD_Chr(char row, char column, char out_char) {
;lcd_i2c.c,66 :: 		char rs = HEX01;
	MOVLW       1
	MOVWF       LCD_Chr_rs_L0+0 
;lcd_i2c.c,68 :: 		column--;
	DECF        FARG_LCD_Chr_column+0, 1 
;lcd_i2c.c,69 :: 		switch(row){
	GOTO        L_LCD_Chr81
;lcd_i2c.c,70 :: 		case 1:
L_LCD_Chr83:
;lcd_i2c.c,71 :: 		LCD_Cmd(HEX80+column);
	MOVF        FARG_LCD_Chr_column+0, 0 
	ADDLW       128
	MOVWF       FARG_LCD_Cmd_out_char+0 
	CALL        _LCD_Cmd+0, 0
;lcd_i2c.c,72 :: 		break;
	GOTO        L_LCD_Chr82
;lcd_i2c.c,73 :: 		case 2:
L_LCD_Chr84:
;lcd_i2c.c,74 :: 		LCD_Cmd(HEXC0+column);
	MOVF        FARG_LCD_Chr_column+0, 0 
	ADDLW       192
	MOVWF       FARG_LCD_Cmd_out_char+0 
	CALL        _LCD_Cmd+0, 0
;lcd_i2c.c,75 :: 		break;
	GOTO        L_LCD_Chr82
;lcd_i2c.c,76 :: 		case 3:
L_LCD_Chr85:
;lcd_i2c.c,77 :: 		LCD_Cmd(HEX94+column);
	MOVF        FARG_LCD_Chr_column+0, 0 
	ADDLW       148
	MOVWF       FARG_LCD_Cmd_out_char+0 
	CALL        _LCD_Cmd+0, 0
;lcd_i2c.c,78 :: 		break;
	GOTO        L_LCD_Chr82
;lcd_i2c.c,79 :: 		case 4:
L_LCD_Chr86:
;lcd_i2c.c,80 :: 		LCD_Cmd(HEXD4+column);
	MOVF        FARG_LCD_Chr_column+0, 0 
	ADDLW       212
	MOVWF       FARG_LCD_Cmd_out_char+0 
	CALL        _LCD_Cmd+0, 0
;lcd_i2c.c,81 :: 		break;
	GOTO        L_LCD_Chr82
;lcd_i2c.c,82 :: 		};
L_LCD_Chr81:
	MOVF        FARG_LCD_Chr_row+0, 0 
	XORLW       1
	BTFSC       STATUS+0, 2 
	GOTO        L_LCD_Chr83
	MOVF        FARG_LCD_Chr_row+0, 0 
	XORLW       2
	BTFSC       STATUS+0, 2 
	GOTO        L_LCD_Chr84
	MOVF        FARG_LCD_Chr_row+0, 0 
	XORLW       3
	BTFSC       STATUS+0, 2 
	GOTO        L_LCD_Chr85
	MOVF        FARG_LCD_Chr_row+0, 0 
	XORLW       4
	BTFSC       STATUS+0, 2 
	GOTO        L_LCD_Chr86
L_LCD_Chr82:
;lcd_i2c.c,84 :: 		hi_n = out_char & HEXF0;
	MOVLW       240
	ANDWF       FARG_LCD_Chr_out_char+0, 0 
	MOVWF       LCD_Chr_hi_n_L0+0 
;lcd_i2c.c,85 :: 		lo_n = (out_char << 4) & HEXF0;
	MOVF        FARG_LCD_Chr_out_char+0, 0 
	MOVWF       LCD_Chr_lo_n_L0+0 
	RLCF        LCD_Chr_lo_n_L0+0, 1 
	BCF         LCD_Chr_lo_n_L0+0, 0 
	RLCF        LCD_Chr_lo_n_L0+0, 1 
	BCF         LCD_Chr_lo_n_L0+0, 0 
	RLCF        LCD_Chr_lo_n_L0+0, 1 
	BCF         LCD_Chr_lo_n_L0+0, 0 
	RLCF        LCD_Chr_lo_n_L0+0, 1 
	BCF         LCD_Chr_lo_n_L0+0, 0 
	MOVLW       240
	ANDWF       LCD_Chr_lo_n_L0+0, 1 
;lcd_i2c.c,87 :: 		I2C1_Start();
	CALL        _I2C1_Start+0, 0
;lcd_i2c.c,88 :: 		I2C1_Is_Idle();
	CALL        _I2C1_Is_Idle+0, 0
;lcd_i2c.c,89 :: 		I2C1_Wr(LCD_ADDR);
	MOVLW       78
	MOVWF       FARG_I2C1_Wr_data_+0 
	CALL        _I2C1_Wr+0, 0
;lcd_i2c.c,90 :: 		I2C1_Is_Idle();
	CALL        _I2C1_Is_Idle+0, 0
;lcd_i2c.c,91 :: 		I2C1_Wr(hi_n | rs | HEX04 | HEX08);
	MOVF        LCD_Chr_rs_L0+0, 0 
	IORWF       LCD_Chr_hi_n_L0+0, 0 
	MOVWF       FARG_I2C1_Wr_data_+0 
	BSF         FARG_I2C1_Wr_data_+0, 2 
	BSF         FARG_I2C1_Wr_data_+0, 3 
	CALL        _I2C1_Wr+0, 0
;lcd_i2c.c,92 :: 		I2C1_Is_Idle();
	CALL        _I2C1_Is_Idle+0, 0
;lcd_i2c.c,93 :: 		Delay_50us();
	CALL        _Delay_50us+0, 0
;lcd_i2c.c,94 :: 		I2C1_Wr(hi_n | rs | HEX00 | HEX08);
	MOVF        LCD_Chr_rs_L0+0, 0 
	IORWF       LCD_Chr_hi_n_L0+0, 0 
	MOVWF       FARG_I2C1_Wr_data_+0 
	BSF         FARG_I2C1_Wr_data_+0, 3 
	CALL        _I2C1_Wr+0, 0
;lcd_i2c.c,95 :: 		I2C1_Is_Idle();
	CALL        _I2C1_Is_Idle+0, 0
;lcd_i2c.c,96 :: 		Delay_50us();
	CALL        _Delay_50us+0, 0
;lcd_i2c.c,97 :: 		Delay_50us();
	CALL        _Delay_50us+0, 0
;lcd_i2c.c,98 :: 		I2C1_Wr(lo_n | rs | HEX04 | HEX08);
	MOVF        LCD_Chr_rs_L0+0, 0 
	IORWF       LCD_Chr_lo_n_L0+0, 0 
	MOVWF       FARG_I2C1_Wr_data_+0 
	BSF         FARG_I2C1_Wr_data_+0, 2 
	BSF         FARG_I2C1_Wr_data_+0, 3 
	CALL        _I2C1_Wr+0, 0
;lcd_i2c.c,99 :: 		I2C1_Is_Idle();
	CALL        _I2C1_Is_Idle+0, 0
;lcd_i2c.c,100 :: 		Delay_50us();
	CALL        _Delay_50us+0, 0
;lcd_i2c.c,101 :: 		I2C1_Wr(lo_n | rs | HEX00 | HEX08);
	MOVF        LCD_Chr_rs_L0+0, 0 
	IORWF       LCD_Chr_lo_n_L0+0, 0 
	MOVWF       FARG_I2C1_Wr_data_+0 
	BSF         FARG_I2C1_Wr_data_+0, 3 
	CALL        _I2C1_Wr+0, 0
;lcd_i2c.c,102 :: 		I2C1_Is_Idle();
	CALL        _I2C1_Is_Idle+0, 0
;lcd_i2c.c,103 :: 		I2C1_stop();
	CALL        _I2C1_Stop+0, 0
;lcd_i2c.c,104 :: 		}
L_end_LCD_Chr:
	RETURN      0
; end of _LCD_Chr

_LCD_Chr_Cp:

;lcd_i2c.c,106 :: 		void LCD_Chr_Cp(char out_char) {
;lcd_i2c.c,108 :: 		char rs = HEX01;
	MOVLW       1
	MOVWF       LCD_Chr_Cp_rs_L0+0 
;lcd_i2c.c,110 :: 		hi_n = out_char & HEXF0;
	MOVLW       240
	ANDWF       FARG_LCD_Chr_Cp_out_char+0, 0 
	MOVWF       LCD_Chr_Cp_hi_n_L0+0 
;lcd_i2c.c,111 :: 		lo_n = (out_char << 4) & HEXF0;
	MOVF        FARG_LCD_Chr_Cp_out_char+0, 0 
	MOVWF       LCD_Chr_Cp_lo_n_L0+0 
	RLCF        LCD_Chr_Cp_lo_n_L0+0, 1 
	BCF         LCD_Chr_Cp_lo_n_L0+0, 0 
	RLCF        LCD_Chr_Cp_lo_n_L0+0, 1 
	BCF         LCD_Chr_Cp_lo_n_L0+0, 0 
	RLCF        LCD_Chr_Cp_lo_n_L0+0, 1 
	BCF         LCD_Chr_Cp_lo_n_L0+0, 0 
	RLCF        LCD_Chr_Cp_lo_n_L0+0, 1 
	BCF         LCD_Chr_Cp_lo_n_L0+0, 0 
	MOVLW       240
	ANDWF       LCD_Chr_Cp_lo_n_L0+0, 1 
;lcd_i2c.c,113 :: 		I2C1_Start();
	CALL        _I2C1_Start+0, 0
;lcd_i2c.c,114 :: 		I2C1_Is_Idle();
	CALL        _I2C1_Is_Idle+0, 0
;lcd_i2c.c,115 :: 		I2C1_Wr(LCD_ADDR);
	MOVLW       78
	MOVWF       FARG_I2C1_Wr_data_+0 
	CALL        _I2C1_Wr+0, 0
;lcd_i2c.c,116 :: 		I2C1_Is_Idle();
	CALL        _I2C1_Is_Idle+0, 0
;lcd_i2c.c,117 :: 		I2C1_Wr(hi_n | rs | HEX04 | HEX08);
	MOVF        LCD_Chr_Cp_rs_L0+0, 0 
	IORWF       LCD_Chr_Cp_hi_n_L0+0, 0 
	MOVWF       FARG_I2C1_Wr_data_+0 
	BSF         FARG_I2C1_Wr_data_+0, 2 
	BSF         FARG_I2C1_Wr_data_+0, 3 
	CALL        _I2C1_Wr+0, 0
;lcd_i2c.c,118 :: 		I2C1_Is_Idle();
	CALL        _I2C1_Is_Idle+0, 0
;lcd_i2c.c,119 :: 		Delay_50us();
	CALL        _Delay_50us+0, 0
;lcd_i2c.c,120 :: 		I2C1_Wr(hi_n | rs | HEX00 | HEX08);
	MOVF        LCD_Chr_Cp_rs_L0+0, 0 
	IORWF       LCD_Chr_Cp_hi_n_L0+0, 0 
	MOVWF       FARG_I2C1_Wr_data_+0 
	BSF         FARG_I2C1_Wr_data_+0, 3 
	CALL        _I2C1_Wr+0, 0
;lcd_i2c.c,121 :: 		I2C1_Is_Idle();
	CALL        _I2C1_Is_Idle+0, 0
;lcd_i2c.c,122 :: 		Delay_50us();
	CALL        _Delay_50us+0, 0
;lcd_i2c.c,123 :: 		Delay_50us();
	CALL        _Delay_50us+0, 0
;lcd_i2c.c,124 :: 		I2C1_Wr(lo_n | rs | HEX04 | HEX08);
	MOVF        LCD_Chr_Cp_rs_L0+0, 0 
	IORWF       LCD_Chr_Cp_lo_n_L0+0, 0 
	MOVWF       FARG_I2C1_Wr_data_+0 
	BSF         FARG_I2C1_Wr_data_+0, 2 
	BSF         FARG_I2C1_Wr_data_+0, 3 
	CALL        _I2C1_Wr+0, 0
;lcd_i2c.c,125 :: 		I2C1_Is_Idle();
	CALL        _I2C1_Is_Idle+0, 0
;lcd_i2c.c,126 :: 		Delay_50us();
	CALL        _Delay_50us+0, 0
;lcd_i2c.c,127 :: 		I2C1_Wr(lo_n | rs | HEX00 | HEX08);
	MOVF        LCD_Chr_Cp_rs_L0+0, 0 
	IORWF       LCD_Chr_Cp_lo_n_L0+0, 0 
	MOVWF       FARG_I2C1_Wr_data_+0 
	BSF         FARG_I2C1_Wr_data_+0, 3 
	CALL        _I2C1_Wr+0, 0
;lcd_i2c.c,128 :: 		I2C1_Is_Idle();
	CALL        _I2C1_Is_Idle+0, 0
;lcd_i2c.c,129 :: 		I2C1_stop();
	CALL        _I2C1_Stop+0, 0
;lcd_i2c.c,130 :: 		}
L_end_LCD_Chr_Cp:
	RETURN      0
; end of _LCD_Chr_Cp

_LCD_Init:

;lcd_i2c.c,133 :: 		void LCD_Init() {
;lcd_i2c.c,134 :: 		char rs = HEX00;
	CLRF        LCD_Init_rs_L0+0 
;lcd_i2c.c,136 :: 		I2C1_Start();
	CALL        _I2C1_Start+0, 0
;lcd_i2c.c,137 :: 		I2C1_Is_Idle();
	CALL        _I2C1_Is_Idle+0, 0
;lcd_i2c.c,138 :: 		I2C1_Wr(LCD_ADDR);
	MOVLW       78
	MOVWF       FARG_I2C1_Wr_data_+0 
	CALL        _I2C1_Wr+0, 0
;lcd_i2c.c,139 :: 		I2C1_Is_Idle();
	CALL        _I2C1_Is_Idle+0, 0
;lcd_i2c.c,141 :: 		Delay_10ms();
	CALL        _Delay_10ms+0, 0
;lcd_i2c.c,142 :: 		Delay_10ms();
	CALL        _Delay_10ms+0, 0
;lcd_i2c.c,143 :: 		Delay_10ms();
	CALL        _Delay_10ms+0, 0
;lcd_i2c.c,145 :: 		I2C1_Wr(HEX30 | rs | HEX04 | HEX08);
	MOVLW       48
	IORWF       LCD_Init_rs_L0+0, 0 
	MOVWF       FARG_I2C1_Wr_data_+0 
	BSF         FARG_I2C1_Wr_data_+0, 2 
	BSF         FARG_I2C1_Wr_data_+0, 3 
	CALL        _I2C1_Wr+0, 0
;lcd_i2c.c,146 :: 		I2C1_Is_Idle();
	CALL        _I2C1_Is_Idle+0, 0
;lcd_i2c.c,147 :: 		Delay_50us();
	CALL        _Delay_50us+0, 0
;lcd_i2c.c,148 :: 		I2C1_Wr(HEX30 | rs | HEX00 | HEX08);
	MOVLW       48
	IORWF       LCD_Init_rs_L0+0, 0 
	MOVWF       FARG_I2C1_Wr_data_+0 
	BSF         FARG_I2C1_Wr_data_+0, 3 
	CALL        _I2C1_Wr+0, 0
;lcd_i2c.c,149 :: 		I2C1_Is_Idle();
	CALL        _I2C1_Is_Idle+0, 0
;lcd_i2c.c,151 :: 		Delay_10ms();
	CALL        _Delay_10ms+0, 0
;lcd_i2c.c,153 :: 		I2C1_Wr(HEX30 | rs | HEX04 | HEX08);
	MOVLW       48
	IORWF       LCD_Init_rs_L0+0, 0 
	MOVWF       FARG_I2C1_Wr_data_+0 
	BSF         FARG_I2C1_Wr_data_+0, 2 
	BSF         FARG_I2C1_Wr_data_+0, 3 
	CALL        _I2C1_Wr+0, 0
;lcd_i2c.c,154 :: 		I2C1_Is_Idle();
	CALL        _I2C1_Is_Idle+0, 0
;lcd_i2c.c,155 :: 		Delay_50us();
	CALL        _Delay_50us+0, 0
;lcd_i2c.c,156 :: 		I2C1_Wr(HEX30 | rs | HEX00 | HEX08);
	MOVLW       48
	IORWF       LCD_Init_rs_L0+0, 0 
	MOVWF       FARG_I2C1_Wr_data_+0 
	BSF         FARG_I2C1_Wr_data_+0, 3 
	CALL        _I2C1_Wr+0, 0
;lcd_i2c.c,157 :: 		I2C1_Is_Idle();
	CALL        _I2C1_Is_Idle+0, 0
;lcd_i2c.c,159 :: 		Delay_10ms();
	CALL        _Delay_10ms+0, 0
;lcd_i2c.c,161 :: 		I2C1_Wr(HEX30 | rs | HEX04 | HEX08);
	MOVLW       48
	IORWF       LCD_Init_rs_L0+0, 0 
	MOVWF       FARG_I2C1_Wr_data_+0 
	BSF         FARG_I2C1_Wr_data_+0, 2 
	BSF         FARG_I2C1_Wr_data_+0, 3 
	CALL        _I2C1_Wr+0, 0
;lcd_i2c.c,162 :: 		I2C1_Is_Idle();
	CALL        _I2C1_Is_Idle+0, 0
;lcd_i2c.c,163 :: 		Delay_10ms();
	CALL        _Delay_10ms+0, 0
;lcd_i2c.c,164 :: 		Delay_10ms();
	CALL        _Delay_10ms+0, 0
;lcd_i2c.c,165 :: 		Delay_10ms();
	CALL        _Delay_10ms+0, 0
;lcd_i2c.c,166 :: 		Delay_10ms();
	CALL        _Delay_10ms+0, 0
;lcd_i2c.c,167 :: 		Delay_10ms();
	CALL        _Delay_10ms+0, 0
;lcd_i2c.c,168 :: 		I2C1_Wr(HEX30 | rs | HEX00 | HEX08);
	MOVLW       48
	IORWF       LCD_Init_rs_L0+0, 0 
	MOVWF       FARG_I2C1_Wr_data_+0 
	BSF         FARG_I2C1_Wr_data_+0, 3 
	CALL        _I2C1_Wr+0, 0
;lcd_i2c.c,169 :: 		I2C1_Is_Idle();
	CALL        _I2C1_Is_Idle+0, 0
;lcd_i2c.c,171 :: 		Delay_10ms();
	CALL        _Delay_10ms+0, 0
;lcd_i2c.c,173 :: 		I2C1_Wr(HEX20 | rs | HEX04 | HEX08);
	MOVLW       32
	IORWF       LCD_Init_rs_L0+0, 0 
	MOVWF       FARG_I2C1_Wr_data_+0 
	BSF         FARG_I2C1_Wr_data_+0, 2 
	BSF         FARG_I2C1_Wr_data_+0, 3 
	CALL        _I2C1_Wr+0, 0
;lcd_i2c.c,174 :: 		I2C1_Is_Idle();
	CALL        _I2C1_Is_Idle+0, 0
;lcd_i2c.c,175 :: 		Delay_50us();
	CALL        _Delay_50us+0, 0
;lcd_i2c.c,176 :: 		I2C1_Wr(HEX20 | rs | HEX00 | HEX08);
	MOVLW       32
	IORWF       LCD_Init_rs_L0+0, 0 
	MOVWF       FARG_I2C1_Wr_data_+0 
	BSF         FARG_I2C1_Wr_data_+0, 3 
	CALL        _I2C1_Wr+0, 0
;lcd_i2c.c,177 :: 		I2C1_Is_Idle();
	CALL        _I2C1_Is_Idle+0, 0
;lcd_i2c.c,178 :: 		I2C1_Stop();
	CALL        _I2C1_Stop+0, 0
;lcd_i2c.c,180 :: 		Delay_10ms();
	CALL        _Delay_10ms+0, 0
;lcd_i2c.c,182 :: 		LCD_Cmd(HEX28);
	MOVLW       40
	MOVWF       FARG_LCD_Cmd_out_char+0 
	CALL        _LCD_Cmd+0, 0
;lcd_i2c.c,183 :: 		LCD_Cmd(HEX06);
	MOVLW       6
	MOVWF       FARG_LCD_Cmd_out_char+0 
	CALL        _LCD_Cmd+0, 0
;lcd_i2c.c,184 :: 		}
L_end_LCD_Init:
	RETURN      0
; end of _LCD_Init

_LCD_Out:

;lcd_i2c.c,186 :: 		void LCD_Out(char row, char col, char *text) {
;lcd_i2c.c,187 :: 		while(*text)
L_LCD_Out87:
	MOVFF       FARG_LCD_Out_text+0, FSR0L+0
	MOVFF       FARG_LCD_Out_text+1, FSR0H+0
	MOVF        POSTINC0+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_LCD_Out88
;lcd_i2c.c,188 :: 		LCD_Chr(row, col++, *text++);
	MOVF        FARG_LCD_Out_row+0, 0 
	MOVWF       FARG_LCD_Chr_row+0 
	MOVF        FARG_LCD_Out_col+0, 0 
	MOVWF       FARG_LCD_Chr_column+0 
	MOVFF       FARG_LCD_Out_text+0, FSR0L+0
	MOVFF       FARG_LCD_Out_text+1, FSR0H+0
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_LCD_Chr_out_char+0 
	CALL        _LCD_Chr+0, 0
	INCF        FARG_LCD_Out_col+0, 1 
	INFSNZ      FARG_LCD_Out_text+0, 1 
	INCF        FARG_LCD_Out_text+1, 1 
	GOTO        L_LCD_Out87
L_LCD_Out88:
;lcd_i2c.c,189 :: 		}
L_end_LCD_Out:
	RETURN      0
; end of _LCD_Out

_LCD_Out_Cp:

;lcd_i2c.c,191 :: 		void LCD_Out_Cp(char *text) {
;lcd_i2c.c,192 :: 		while(*text)
L_LCD_Out_Cp89:
	MOVFF       FARG_LCD_Out_Cp_text+0, FSR0L+0
	MOVFF       FARG_LCD_Out_Cp_text+1, FSR0H+0
	MOVF        POSTINC0+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_LCD_Out_Cp90
;lcd_i2c.c,193 :: 		LCD_Chr_Cp(*text++);
	MOVFF       FARG_LCD_Out_Cp_text+0, FSR0L+0
	MOVFF       FARG_LCD_Out_Cp_text+1, FSR0H+0
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_LCD_Chr_Cp_out_char+0 
	CALL        _LCD_Chr_Cp+0, 0
	INFSNZ      FARG_LCD_Out_Cp_text+0, 1 
	INCF        FARG_LCD_Out_Cp_text+1, 1 
	GOTO        L_LCD_Out_Cp89
L_LCD_Out_Cp90:
;lcd_i2c.c,194 :: 		}
L_end_LCD_Out_Cp:
	RETURN      0
; end of _LCD_Out_Cp

_main:

;main.c,25 :: 		void main() {
;main.c,27 :: 		TRISA=0b00000000; // [][][MFRC522_RST][LED][SoftSPI_SDI][SoftSPI_SDO][SoftSPI_CLK][MFRC522_CS]
	CLRF        TRISA+0 
;main.c,28 :: 		TRISB=0b00000000; // [][][][][][][SCK][SDA]
	CLRF        TRISB+0 
;main.c,29 :: 		TRISC=0b00000000; // [][][][][][][][]
	CLRF        TRISC+0 
;main.c,30 :: 		TRISD=0b00000000; // [][][][][][][][BUZZER]
	CLRF        TRISD+0 
;main.c,31 :: 		TRISE=0b00000000; // [][][][][][][][]
	CLRF        TRISE+0 
;main.c,34 :: 		ANSELA=0b00000000; // [][][][][][][][]
	CLRF        ANSELA+0 
;main.c,35 :: 		ANSELB=0b00000000; // [][][][][][][][]
	CLRF        ANSELB+0 
;main.c,36 :: 		ANSELC=0b00000000; // [][][][][][][][]
	CLRF        ANSELC+0 
;main.c,37 :: 		ANSELD=0b00000000; // [][][][][][][][]
	CLRF        ANSELD+0 
;main.c,38 :: 		ANSELE=0b00000000; // [][][][][][][][]
	CLRF        ANSELE+0 
;main.c,41 :: 		LATA=0x00;
	CLRF        LATA+0 
;main.c,42 :: 		LATB=0x00;
	CLRF        LATB+0 
;main.c,43 :: 		LATC=0x00;
	CLRF        LATC+0 
;main.c,44 :: 		LATD=0x00;
	CLRF        LATD+0 
;main.c,45 :: 		LATE=0x00;
	CLRF        LATE+0 
;main.c,48 :: 		I2C1_Init(100000); // I2C LCD ktphanesi dahili I2C donanimi ile alismaktadir.
	MOVLW       120
	MOVWF       SSP1ADD+0 
	CALL        _I2C1_Init+0, 0
;main.c,50 :: 		Soft_SPI_Init();   // SPI hazirlama
	CALL        _Soft_SPI_Init+0, 0
;main.c,51 :: 		MFRC522_CS = 1;    // SlaveSelect (SS) RFID aktif
	BSF         RA0_bit+0, BitPos(RA0_bit+0) 
;main.c,52 :: 		MFRC522_Init();    // RC522 modl hazirlama
	CALL        _MFRC522_Init+0, 0
;main.c,53 :: 		delay_ms(1000);    // 1 saniye bekleme
	MOVLW       61
	MOVWF       R11, 0
	MOVLW       225
	MOVWF       R12, 0
	MOVLW       63
	MOVWF       R13, 0
L_main91:
	DECFSZ      R13, 1, 1
	BRA         L_main91
	DECFSZ      R12, 1, 1
	BRA         L_main91
	DECFSZ      R11, 1, 1
	BRA         L_main91
	NOP
	NOP
;main.c,57 :: 		LCD_Init();                           // Ekrani hazirla
	CALL        _LCD_Init+0, 0
;main.c,58 :: 		LCD_Cmd(_LCD_CURSOR_OFF);             // Imleci kapat
	MOVLW       12
	MOVWF       FARG_LCD_Cmd_out_char+0 
	CALL        _LCD_Cmd+0, 0
;main.c,59 :: 		LCD_Cmd(_LCD_CLEAR);                  // Ekrani temizle
	MOVLW       1
	MOVWF       FARG_LCD_Cmd_out_char+0 
	CALL        _LCD_Cmd+0, 0
;main.c,60 :: 		Lcd_Out(1, 1,"   RFID-RC522   ");     // 1.Satir 1.Sutuna yaz
	MOVLW       1
	MOVWF       FARG_LCD_Out_row+0 
	MOVLW       1
	MOVWF       FARG_LCD_Out_col+0 
	MOVLW       ?lstr1_main+0
	MOVWF       FARG_LCD_Out_text+0 
	MOVLW       hi_addr(?lstr1_main+0)
	MOVWF       FARG_LCD_Out_text+1 
	CALL        _LCD_Out+0, 0
;main.c,61 :: 		Lcd_Out(2, 1,"ID:  00:00:00:00");     // 2.Satir 1.Sutuna yaz
	MOVLW       2
	MOVWF       FARG_LCD_Out_row+0 
	MOVLW       1
	MOVWF       FARG_LCD_Out_col+0 
	MOVLW       ?lstr2_main+0
	MOVWF       FARG_LCD_Out_text+0 
	MOVLW       hi_addr(?lstr2_main+0)
	MOVWF       FARG_LCD_Out_text+1 
	CALL        _LCD_Out+0, 0
;main.c,64 :: 		while(1){
L_main92:
;main.c,65 :: 		RC522_ID=MFRC522_GetId();
	CALL        _MFRC522_GetId+0, 0
	MOVF        R0, 0 
	MOVWF       _RC522_ID+0 
	MOVF        R1, 0 
	MOVWF       _RC522_ID+1 
	MOVF        R2, 0 
	MOVWF       _RC522_ID+2 
	MOVF        R3, 0 
	MOVWF       _RC522_ID+3 
;main.c,66 :: 		if(RC522_ID){
	MOVF        R0, 0 
	IORWF       R1, 0 
	IORWF       R2, 0 
	IORWF       R3, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L_main94
;main.c,67 :: 		BUZZER=1; delay_ms(10); BUZZER=0;
	BSF         LATD0_bit+0, BitPos(LATD0_bit+0) 
	MOVLW       156
	MOVWF       R12, 0
	MOVLW       215
	MOVWF       R13, 0
L_main95:
	DECFSZ      R13, 1, 1
	BRA         L_main95
	DECFSZ      R12, 1, 1
	BRA         L_main95
	BCF         LATD0_bit+0, BitPos(LATD0_bit+0) 
;main.c,68 :: 		ByteToHex(RC522_ID>>24, txt); Lcd_Out(2, 6,txt);
	MOVF        _RC522_ID+3, 0 
	MOVWF       R0 
	CLRF        R1 
	CLRF        R2 
	CLRF        R3 
	MOVF        R0, 0 
	MOVWF       FARG_ByteToHex_input+0 
	MOVLW       _txt+0
	MOVWF       FARG_ByteToHex_output+0 
	MOVLW       hi_addr(_txt+0)
	MOVWF       FARG_ByteToHex_output+1 
	CALL        _ByteToHex+0, 0
	MOVLW       2
	MOVWF       FARG_LCD_Out_row+0 
	MOVLW       6
	MOVWF       FARG_LCD_Out_col+0 
	MOVLW       _txt+0
	MOVWF       FARG_LCD_Out_text+0 
	MOVLW       hi_addr(_txt+0)
	MOVWF       FARG_LCD_Out_text+1 
	CALL        _LCD_Out+0, 0
;main.c,69 :: 		ByteToHex(RC522_ID>>16, txt); Lcd_Out(2, 9,txt);
	MOVF        _RC522_ID+2, 0 
	MOVWF       R0 
	MOVF        _RC522_ID+3, 0 
	MOVWF       R1 
	CLRF        R2 
	CLRF        R3 
	MOVF        R0, 0 
	MOVWF       FARG_ByteToHex_input+0 
	MOVLW       _txt+0
	MOVWF       FARG_ByteToHex_output+0 
	MOVLW       hi_addr(_txt+0)
	MOVWF       FARG_ByteToHex_output+1 
	CALL        _ByteToHex+0, 0
	MOVLW       2
	MOVWF       FARG_LCD_Out_row+0 
	MOVLW       9
	MOVWF       FARG_LCD_Out_col+0 
	MOVLW       _txt+0
	MOVWF       FARG_LCD_Out_text+0 
	MOVLW       hi_addr(_txt+0)
	MOVWF       FARG_LCD_Out_text+1 
	CALL        _LCD_Out+0, 0
;main.c,70 :: 		ByteToHex(RC522_ID>>8 , txt); Lcd_Out(2, 12,txt);
	MOVF        _RC522_ID+1, 0 
	MOVWF       R0 
	MOVF        _RC522_ID+2, 0 
	MOVWF       R1 
	MOVF        _RC522_ID+3, 0 
	MOVWF       R2 
	CLRF        R3 
	MOVF        R0, 0 
	MOVWF       FARG_ByteToHex_input+0 
	MOVLW       _txt+0
	MOVWF       FARG_ByteToHex_output+0 
	MOVLW       hi_addr(_txt+0)
	MOVWF       FARG_ByteToHex_output+1 
	CALL        _ByteToHex+0, 0
	MOVLW       2
	MOVWF       FARG_LCD_Out_row+0 
	MOVLW       12
	MOVWF       FARG_LCD_Out_col+0 
	MOVLW       _txt+0
	MOVWF       FARG_LCD_Out_text+0 
	MOVLW       hi_addr(_txt+0)
	MOVWF       FARG_LCD_Out_text+1 
	CALL        _LCD_Out+0, 0
;main.c,71 :: 		ByteToHex(RC522_ID    , txt); Lcd_Out(2, 15,txt);
	MOVF        _RC522_ID+0, 0 
	MOVWF       FARG_ByteToHex_input+0 
	MOVLW       _txt+0
	MOVWF       FARG_ByteToHex_output+0 
	MOVLW       hi_addr(_txt+0)
	MOVWF       FARG_ByteToHex_output+1 
	CALL        _ByteToHex+0, 0
	MOVLW       2
	MOVWF       FARG_LCD_Out_row+0 
	MOVLW       15
	MOVWF       FARG_LCD_Out_col+0 
	MOVLW       _txt+0
	MOVWF       FARG_LCD_Out_text+0 
	MOVLW       hi_addr(_txt+0)
	MOVWF       FARG_LCD_Out_text+1 
	CALL        _LCD_Out+0, 0
;main.c,72 :: 		delay_ms(1000);
	MOVLW       61
	MOVWF       R11, 0
	MOVLW       225
	MOVWF       R12, 0
	MOVLW       63
	MOVWF       R13, 0
L_main96:
	DECFSZ      R13, 1, 1
	BRA         L_main96
	DECFSZ      R12, 1, 1
	BRA         L_main96
	DECFSZ      R11, 1, 1
	BRA         L_main96
	NOP
	NOP
;main.c,73 :: 		}
L_main94:
;main.c,74 :: 		}
	GOTO        L_main92
;main.c,75 :: 		}
L_end_main:
	GOTO        $+0
; end of _main
